import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
export interface DatatransferEndpointConfig extends cdktf.TerraformMetaArguments {
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/datatransfer_endpoint#description DatatransferEndpoint#description}
    */
    readonly description?: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/datatransfer_endpoint#folder_id DatatransferEndpoint#folder_id}
    */
    readonly folderId?: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/datatransfer_endpoint#id DatatransferEndpoint#id}
    *
    * Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
    * If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
    */
    readonly id?: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/datatransfer_endpoint#labels DatatransferEndpoint#labels}
    */
    readonly labels?: {
        [key: string]: string;
    };
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/datatransfer_endpoint#name DatatransferEndpoint#name}
    */
    readonly name?: string;
    /**
    * settings block
    *
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/datatransfer_endpoint#settings DatatransferEndpoint#settings}
    */
    readonly settings?: DatatransferEndpointSettings;
}
export interface DatatransferEndpointSettingsClickhouseSourceConnectionConnectionOptionsOnPremiseShards {
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/datatransfer_endpoint#hosts DatatransferEndpoint#hosts}
    */
    readonly hosts?: string[];
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/datatransfer_endpoint#name DatatransferEndpoint#name}
    */
    readonly name?: string;
}
export declare function datatransferEndpointSettingsClickhouseSourceConnectionConnectionOptionsOnPremiseShardsToTerraform(struct?: DatatransferEndpointSettingsClickhouseSourceConnectionConnectionOptionsOnPremiseShards | cdktf.IResolvable): any;
export declare class DatatransferEndpointSettingsClickhouseSourceConnectionConnectionOptionsOnPremiseShardsOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DatatransferEndpointSettingsClickhouseSourceConnectionConnectionOptionsOnPremiseShards | cdktf.IResolvable | undefined;
    set internalValue(value: DatatransferEndpointSettingsClickhouseSourceConnectionConnectionOptionsOnPremiseShards | cdktf.IResolvable | undefined);
    private _hosts?;
    get hosts(): string[];
    set hosts(value: string[]);
    resetHosts(): void;
    get hostsInput(): string[] | undefined;
    private _name?;
    get name(): string;
    set name(value: string);
    resetName(): void;
    get nameInput(): string | undefined;
}
export declare class DatatransferEndpointSettingsClickhouseSourceConnectionConnectionOptionsOnPremiseShardsList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DatatransferEndpointSettingsClickhouseSourceConnectionConnectionOptionsOnPremiseShards[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DatatransferEndpointSettingsClickhouseSourceConnectionConnectionOptionsOnPremiseShardsOutputReference;
}
export interface DatatransferEndpointSettingsClickhouseSourceConnectionConnectionOptionsOnPremiseTlsModeDisabled {
}
export declare function datatransferEndpointSettingsClickhouseSourceConnectionConnectionOptionsOnPremiseTlsModeDisabledToTerraform(struct?: DatatransferEndpointSettingsClickhouseSourceConnectionConnectionOptionsOnPremiseTlsModeDisabledOutputReference | DatatransferEndpointSettingsClickhouseSourceConnectionConnectionOptionsOnPremiseTlsModeDisabled): any;
export declare class DatatransferEndpointSettingsClickhouseSourceConnectionConnectionOptionsOnPremiseTlsModeDisabledOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DatatransferEndpointSettingsClickhouseSourceConnectionConnectionOptionsOnPremiseTlsModeDisabled | undefined;
    set internalValue(value: DatatransferEndpointSettingsClickhouseSourceConnectionConnectionOptionsOnPremiseTlsModeDisabled | undefined);
}
export interface DatatransferEndpointSettingsClickhouseSourceConnectionConnectionOptionsOnPremiseTlsModeEnabled {
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/datatransfer_endpoint#ca_certificate DatatransferEndpoint#ca_certificate}
    */
    readonly caCertificate?: string;
}
export declare function datatransferEndpointSettingsClickhouseSourceConnectionConnectionOptionsOnPremiseTlsModeEnabledToTerraform(struct?: DatatransferEndpointSettingsClickhouseSourceConnectionConnectionOptionsOnPremiseTlsModeEnabledOutputReference | DatatransferEndpointSettingsClickhouseSourceConnectionConnectionOptionsOnPremiseTlsModeEnabled): any;
export declare class DatatransferEndpointSettingsClickhouseSourceConnectionConnectionOptionsOnPremiseTlsModeEnabledOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DatatransferEndpointSettingsClickhouseSourceConnectionConnectionOptionsOnPremiseTlsModeEnabled | undefined;
    set internalValue(value: DatatransferEndpointSettingsClickhouseSourceConnectionConnectionOptionsOnPremiseTlsModeEnabled | undefined);
    private _caCertificate?;
    get caCertificate(): string;
    set caCertificate(value: string);
    resetCaCertificate(): void;
    get caCertificateInput(): string | undefined;
}
export interface DatatransferEndpointSettingsClickhouseSourceConnectionConnectionOptionsOnPremiseTlsMode {
    /**
    * disabled block
    *
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/datatransfer_endpoint#disabled DatatransferEndpoint#disabled}
    */
    readonly disabled?: DatatransferEndpointSettingsClickhouseSourceConnectionConnectionOptionsOnPremiseTlsModeDisabled;
    /**
    * enabled block
    *
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/datatransfer_endpoint#enabled DatatransferEndpoint#enabled}
    */
    readonly enabled?: DatatransferEndpointSettingsClickhouseSourceConnectionConnectionOptionsOnPremiseTlsModeEnabled;
}
export declare function datatransferEndpointSettingsClickhouseSourceConnectionConnectionOptionsOnPremiseTlsModeToTerraform(struct?: DatatransferEndpointSettingsClickhouseSourceConnectionConnectionOptionsOnPremiseTlsModeOutputReference | DatatransferEndpointSettingsClickhouseSourceConnectionConnectionOptionsOnPremiseTlsMode): any;
export declare class DatatransferEndpointSettingsClickhouseSourceConnectionConnectionOptionsOnPremiseTlsModeOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DatatransferEndpointSettingsClickhouseSourceConnectionConnectionOptionsOnPremiseTlsMode | undefined;
    set internalValue(value: DatatransferEndpointSettingsClickhouseSourceConnectionConnectionOptionsOnPremiseTlsMode | undefined);
    private _disabled;
    get disabled(): DatatransferEndpointSettingsClickhouseSourceConnectionConnectionOptionsOnPremiseTlsModeDisabledOutputReference;
    putDisabled(value: DatatransferEndpointSettingsClickhouseSourceConnectionConnectionOptionsOnPremiseTlsModeDisabled): void;
    resetDisabled(): void;
    get disabledInput(): DatatransferEndpointSettingsClickhouseSourceConnectionConnectionOptionsOnPremiseTlsModeDisabled | undefined;
    private _enabled;
    get enabled(): DatatransferEndpointSettingsClickhouseSourceConnectionConnectionOptionsOnPremiseTlsModeEnabledOutputReference;
    putEnabled(value: DatatransferEndpointSettingsClickhouseSourceConnectionConnectionOptionsOnPremiseTlsModeEnabled): void;
    resetEnabled(): void;
    get enabledInput(): DatatransferEndpointSettingsClickhouseSourceConnectionConnectionOptionsOnPremiseTlsModeEnabled | undefined;
}
export interface DatatransferEndpointSettingsClickhouseSourceConnectionConnectionOptionsOnPremise {
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/datatransfer_endpoint#http_port DatatransferEndpoint#http_port}
    */
    readonly httpPort?: number;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/datatransfer_endpoint#native_port DatatransferEndpoint#native_port}
    */
    readonly nativePort?: number;
    /**
    * shards block
    *
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/datatransfer_endpoint#shards DatatransferEndpoint#shards}
    */
    readonly shards?: DatatransferEndpointSettingsClickhouseSourceConnectionConnectionOptionsOnPremiseShards[] | cdktf.IResolvable;
    /**
    * tls_mode block
    *
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/datatransfer_endpoint#tls_mode DatatransferEndpoint#tls_mode}
    */
    readonly tlsMode?: DatatransferEndpointSettingsClickhouseSourceConnectionConnectionOptionsOnPremiseTlsMode;
}
export declare function datatransferEndpointSettingsClickhouseSourceConnectionConnectionOptionsOnPremiseToTerraform(struct?: DatatransferEndpointSettingsClickhouseSourceConnectionConnectionOptionsOnPremiseOutputReference | DatatransferEndpointSettingsClickhouseSourceConnectionConnectionOptionsOnPremise): any;
export declare class DatatransferEndpointSettingsClickhouseSourceConnectionConnectionOptionsOnPremiseOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DatatransferEndpointSettingsClickhouseSourceConnectionConnectionOptionsOnPremise | undefined;
    set internalValue(value: DatatransferEndpointSettingsClickhouseSourceConnectionConnectionOptionsOnPremise | undefined);
    private _httpPort?;
    get httpPort(): number;
    set httpPort(value: number);
    resetHttpPort(): void;
    get httpPortInput(): number | undefined;
    private _nativePort?;
    get nativePort(): number;
    set nativePort(value: number);
    resetNativePort(): void;
    get nativePortInput(): number | undefined;
    private _shards;
    get shards(): DatatransferEndpointSettingsClickhouseSourceConnectionConnectionOptionsOnPremiseShardsList;
    putShards(value: DatatransferEndpointSettingsClickhouseSourceConnectionConnectionOptionsOnPremiseShards[] | cdktf.IResolvable): void;
    resetShards(): void;
    get shardsInput(): cdktf.IResolvable | DatatransferEndpointSettingsClickhouseSourceConnectionConnectionOptionsOnPremiseShards[] | undefined;
    private _tlsMode;
    get tlsMode(): DatatransferEndpointSettingsClickhouseSourceConnectionConnectionOptionsOnPremiseTlsModeOutputReference;
    putTlsMode(value: DatatransferEndpointSettingsClickhouseSourceConnectionConnectionOptionsOnPremiseTlsMode): void;
    resetTlsMode(): void;
    get tlsModeInput(): DatatransferEndpointSettingsClickhouseSourceConnectionConnectionOptionsOnPremiseTlsMode | undefined;
}
export interface DatatransferEndpointSettingsClickhouseSourceConnectionConnectionOptionsPassword {
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/datatransfer_endpoint#raw DatatransferEndpoint#raw}
    */
    readonly raw?: string;
}
export declare function datatransferEndpointSettingsClickhouseSourceConnectionConnectionOptionsPasswordToTerraform(struct?: DatatransferEndpointSettingsClickhouseSourceConnectionConnectionOptionsPasswordOutputReference | DatatransferEndpointSettingsClickhouseSourceConnectionConnectionOptionsPassword): any;
export declare class DatatransferEndpointSettingsClickhouseSourceConnectionConnectionOptionsPasswordOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DatatransferEndpointSettingsClickhouseSourceConnectionConnectionOptionsPassword | undefined;
    set internalValue(value: DatatransferEndpointSettingsClickhouseSourceConnectionConnectionOptionsPassword | undefined);
    private _raw?;
    get raw(): string;
    set raw(value: string);
    resetRaw(): void;
    get rawInput(): string | undefined;
}
export interface DatatransferEndpointSettingsClickhouseSourceConnectionConnectionOptions {
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/datatransfer_endpoint#database DatatransferEndpoint#database}
    */
    readonly database?: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/datatransfer_endpoint#mdb_cluster_id DatatransferEndpoint#mdb_cluster_id}
    */
    readonly mdbClusterId?: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/datatransfer_endpoint#user DatatransferEndpoint#user}
    */
    readonly user?: string;
    /**
    * on_premise block
    *
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/datatransfer_endpoint#on_premise DatatransferEndpoint#on_premise}
    */
    readonly onPremise?: DatatransferEndpointSettingsClickhouseSourceConnectionConnectionOptionsOnPremise;
    /**
    * password block
    *
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/datatransfer_endpoint#password DatatransferEndpoint#password}
    */
    readonly password?: DatatransferEndpointSettingsClickhouseSourceConnectionConnectionOptionsPassword;
}
export declare function datatransferEndpointSettingsClickhouseSourceConnectionConnectionOptionsToTerraform(struct?: DatatransferEndpointSettingsClickhouseSourceConnectionConnectionOptionsOutputReference | DatatransferEndpointSettingsClickhouseSourceConnectionConnectionOptions): any;
export declare class DatatransferEndpointSettingsClickhouseSourceConnectionConnectionOptionsOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DatatransferEndpointSettingsClickhouseSourceConnectionConnectionOptions | undefined;
    set internalValue(value: DatatransferEndpointSettingsClickhouseSourceConnectionConnectionOptions | undefined);
    private _database?;
    get database(): string;
    set database(value: string);
    resetDatabase(): void;
    get databaseInput(): string | undefined;
    private _mdbClusterId?;
    get mdbClusterId(): string;
    set mdbClusterId(value: string);
    resetMdbClusterId(): void;
    get mdbClusterIdInput(): string | undefined;
    private _user?;
    get user(): string;
    set user(value: string);
    resetUser(): void;
    get userInput(): string | undefined;
    private _onPremise;
    get onPremise(): DatatransferEndpointSettingsClickhouseSourceConnectionConnectionOptionsOnPremiseOutputReference;
    putOnPremise(value: DatatransferEndpointSettingsClickhouseSourceConnectionConnectionOptionsOnPremise): void;
    resetOnPremise(): void;
    get onPremiseInput(): DatatransferEndpointSettingsClickhouseSourceConnectionConnectionOptionsOnPremise | undefined;
    private _password;
    get password(): DatatransferEndpointSettingsClickhouseSourceConnectionConnectionOptionsPasswordOutputReference;
    putPassword(value: DatatransferEndpointSettingsClickhouseSourceConnectionConnectionOptionsPassword): void;
    resetPassword(): void;
    get passwordInput(): DatatransferEndpointSettingsClickhouseSourceConnectionConnectionOptionsPassword | undefined;
}
export interface DatatransferEndpointSettingsClickhouseSourceConnection {
    /**
    * connection_options block
    *
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/datatransfer_endpoint#connection_options DatatransferEndpoint#connection_options}
    */
    readonly connectionOptions?: DatatransferEndpointSettingsClickhouseSourceConnectionConnectionOptions;
}
export declare function datatransferEndpointSettingsClickhouseSourceConnectionToTerraform(struct?: DatatransferEndpointSettingsClickhouseSourceConnectionOutputReference | DatatransferEndpointSettingsClickhouseSourceConnection): any;
export declare class DatatransferEndpointSettingsClickhouseSourceConnectionOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DatatransferEndpointSettingsClickhouseSourceConnection | undefined;
    set internalValue(value: DatatransferEndpointSettingsClickhouseSourceConnection | undefined);
    private _connectionOptions;
    get connectionOptions(): DatatransferEndpointSettingsClickhouseSourceConnectionConnectionOptionsOutputReference;
    putConnectionOptions(value: DatatransferEndpointSettingsClickhouseSourceConnectionConnectionOptions): void;
    resetConnectionOptions(): void;
    get connectionOptionsInput(): DatatransferEndpointSettingsClickhouseSourceConnectionConnectionOptions | undefined;
}
export interface DatatransferEndpointSettingsClickhouseSource {
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/datatransfer_endpoint#exclude_tables DatatransferEndpoint#exclude_tables}
    */
    readonly excludeTables?: string[];
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/datatransfer_endpoint#include_tables DatatransferEndpoint#include_tables}
    */
    readonly includeTables?: string[];
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/datatransfer_endpoint#security_groups DatatransferEndpoint#security_groups}
    */
    readonly securityGroups?: string[];
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/datatransfer_endpoint#subnet_id DatatransferEndpoint#subnet_id}
    */
    readonly subnetId?: string;
    /**
    * connection block
    *
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/datatransfer_endpoint#connection DatatransferEndpoint#connection}
    */
    readonly connection?: DatatransferEndpointSettingsClickhouseSourceConnection;
}
export declare function datatransferEndpointSettingsClickhouseSourceToTerraform(struct?: DatatransferEndpointSettingsClickhouseSourceOutputReference | DatatransferEndpointSettingsClickhouseSource): any;
export declare class DatatransferEndpointSettingsClickhouseSourceOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DatatransferEndpointSettingsClickhouseSource | undefined;
    set internalValue(value: DatatransferEndpointSettingsClickhouseSource | undefined);
    private _excludeTables?;
    get excludeTables(): string[];
    set excludeTables(value: string[]);
    resetExcludeTables(): void;
    get excludeTablesInput(): string[] | undefined;
    private _includeTables?;
    get includeTables(): string[];
    set includeTables(value: string[]);
    resetIncludeTables(): void;
    get includeTablesInput(): string[] | undefined;
    private _securityGroups?;
    get securityGroups(): string[];
    set securityGroups(value: string[]);
    resetSecurityGroups(): void;
    get securityGroupsInput(): string[] | undefined;
    private _subnetId?;
    get subnetId(): string;
    set subnetId(value: string);
    resetSubnetId(): void;
    get subnetIdInput(): string | undefined;
    private _connection;
    get connection(): DatatransferEndpointSettingsClickhouseSourceConnectionOutputReference;
    putConnection(value: DatatransferEndpointSettingsClickhouseSourceConnection): void;
    resetConnection(): void;
    get connectionInput(): DatatransferEndpointSettingsClickhouseSourceConnection | undefined;
}
export interface DatatransferEndpointSettingsClickhouseTargetAltNames {
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/datatransfer_endpoint#from_name DatatransferEndpoint#from_name}
    */
    readonly fromName?: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/datatransfer_endpoint#to_name DatatransferEndpoint#to_name}
    */
    readonly toName?: string;
}
export declare function datatransferEndpointSettingsClickhouseTargetAltNamesToTerraform(struct?: DatatransferEndpointSettingsClickhouseTargetAltNames | cdktf.IResolvable): any;
export declare class DatatransferEndpointSettingsClickhouseTargetAltNamesOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DatatransferEndpointSettingsClickhouseTargetAltNames | cdktf.IResolvable | undefined;
    set internalValue(value: DatatransferEndpointSettingsClickhouseTargetAltNames | cdktf.IResolvable | undefined);
    private _fromName?;
    get fromName(): string;
    set fromName(value: string);
    resetFromName(): void;
    get fromNameInput(): string | undefined;
    private _toName?;
    get toName(): string;
    set toName(value: string);
    resetToName(): void;
    get toNameInput(): string | undefined;
}
export declare class DatatransferEndpointSettingsClickhouseTargetAltNamesList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DatatransferEndpointSettingsClickhouseTargetAltNames[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DatatransferEndpointSettingsClickhouseTargetAltNamesOutputReference;
}
export interface DatatransferEndpointSettingsClickhouseTargetConnectionConnectionOptionsOnPremiseShards {
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/datatransfer_endpoint#hosts DatatransferEndpoint#hosts}
    */
    readonly hosts?: string[];
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/datatransfer_endpoint#name DatatransferEndpoint#name}
    */
    readonly name?: string;
}
export declare function datatransferEndpointSettingsClickhouseTargetConnectionConnectionOptionsOnPremiseShardsToTerraform(struct?: DatatransferEndpointSettingsClickhouseTargetConnectionConnectionOptionsOnPremiseShards | cdktf.IResolvable): any;
export declare class DatatransferEndpointSettingsClickhouseTargetConnectionConnectionOptionsOnPremiseShardsOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DatatransferEndpointSettingsClickhouseTargetConnectionConnectionOptionsOnPremiseShards | cdktf.IResolvable | undefined;
    set internalValue(value: DatatransferEndpointSettingsClickhouseTargetConnectionConnectionOptionsOnPremiseShards | cdktf.IResolvable | undefined);
    private _hosts?;
    get hosts(): string[];
    set hosts(value: string[]);
    resetHosts(): void;
    get hostsInput(): string[] | undefined;
    private _name?;
    get name(): string;
    set name(value: string);
    resetName(): void;
    get nameInput(): string | undefined;
}
export declare class DatatransferEndpointSettingsClickhouseTargetConnectionConnectionOptionsOnPremiseShardsList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DatatransferEndpointSettingsClickhouseTargetConnectionConnectionOptionsOnPremiseShards[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DatatransferEndpointSettingsClickhouseTargetConnectionConnectionOptionsOnPremiseShardsOutputReference;
}
export interface DatatransferEndpointSettingsClickhouseTargetConnectionConnectionOptionsOnPremiseTlsModeDisabled {
}
export declare function datatransferEndpointSettingsClickhouseTargetConnectionConnectionOptionsOnPremiseTlsModeDisabledToTerraform(struct?: DatatransferEndpointSettingsClickhouseTargetConnectionConnectionOptionsOnPremiseTlsModeDisabledOutputReference | DatatransferEndpointSettingsClickhouseTargetConnectionConnectionOptionsOnPremiseTlsModeDisabled): any;
export declare class DatatransferEndpointSettingsClickhouseTargetConnectionConnectionOptionsOnPremiseTlsModeDisabledOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DatatransferEndpointSettingsClickhouseTargetConnectionConnectionOptionsOnPremiseTlsModeDisabled | undefined;
    set internalValue(value: DatatransferEndpointSettingsClickhouseTargetConnectionConnectionOptionsOnPremiseTlsModeDisabled | undefined);
}
export interface DatatransferEndpointSettingsClickhouseTargetConnectionConnectionOptionsOnPremiseTlsModeEnabled {
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/datatransfer_endpoint#ca_certificate DatatransferEndpoint#ca_certificate}
    */
    readonly caCertificate?: string;
}
export declare function datatransferEndpointSettingsClickhouseTargetConnectionConnectionOptionsOnPremiseTlsModeEnabledToTerraform(struct?: DatatransferEndpointSettingsClickhouseTargetConnectionConnectionOptionsOnPremiseTlsModeEnabledOutputReference | DatatransferEndpointSettingsClickhouseTargetConnectionConnectionOptionsOnPremiseTlsModeEnabled): any;
export declare class DatatransferEndpointSettingsClickhouseTargetConnectionConnectionOptionsOnPremiseTlsModeEnabledOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DatatransferEndpointSettingsClickhouseTargetConnectionConnectionOptionsOnPremiseTlsModeEnabled | undefined;
    set internalValue(value: DatatransferEndpointSettingsClickhouseTargetConnectionConnectionOptionsOnPremiseTlsModeEnabled | undefined);
    private _caCertificate?;
    get caCertificate(): string;
    set caCertificate(value: string);
    resetCaCertificate(): void;
    get caCertificateInput(): string | undefined;
}
export interface DatatransferEndpointSettingsClickhouseTargetConnectionConnectionOptionsOnPremiseTlsMode {
    /**
    * disabled block
    *
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/datatransfer_endpoint#disabled DatatransferEndpoint#disabled}
    */
    readonly disabled?: DatatransferEndpointSettingsClickhouseTargetConnectionConnectionOptionsOnPremiseTlsModeDisabled;
    /**
    * enabled block
    *
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/datatransfer_endpoint#enabled DatatransferEndpoint#enabled}
    */
    readonly enabled?: DatatransferEndpointSettingsClickhouseTargetConnectionConnectionOptionsOnPremiseTlsModeEnabled;
}
export declare function datatransferEndpointSettingsClickhouseTargetConnectionConnectionOptionsOnPremiseTlsModeToTerraform(struct?: DatatransferEndpointSettingsClickhouseTargetConnectionConnectionOptionsOnPremiseTlsModeOutputReference | DatatransferEndpointSettingsClickhouseTargetConnectionConnectionOptionsOnPremiseTlsMode): any;
export declare class DatatransferEndpointSettingsClickhouseTargetConnectionConnectionOptionsOnPremiseTlsModeOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DatatransferEndpointSettingsClickhouseTargetConnectionConnectionOptionsOnPremiseTlsMode | undefined;
    set internalValue(value: DatatransferEndpointSettingsClickhouseTargetConnectionConnectionOptionsOnPremiseTlsMode | undefined);
    private _disabled;
    get disabled(): DatatransferEndpointSettingsClickhouseTargetConnectionConnectionOptionsOnPremiseTlsModeDisabledOutputReference;
    putDisabled(value: DatatransferEndpointSettingsClickhouseTargetConnectionConnectionOptionsOnPremiseTlsModeDisabled): void;
    resetDisabled(): void;
    get disabledInput(): DatatransferEndpointSettingsClickhouseTargetConnectionConnectionOptionsOnPremiseTlsModeDisabled | undefined;
    private _enabled;
    get enabled(): DatatransferEndpointSettingsClickhouseTargetConnectionConnectionOptionsOnPremiseTlsModeEnabledOutputReference;
    putEnabled(value: DatatransferEndpointSettingsClickhouseTargetConnectionConnectionOptionsOnPremiseTlsModeEnabled): void;
    resetEnabled(): void;
    get enabledInput(): DatatransferEndpointSettingsClickhouseTargetConnectionConnectionOptionsOnPremiseTlsModeEnabled | undefined;
}
export interface DatatransferEndpointSettingsClickhouseTargetConnectionConnectionOptionsOnPremise {
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/datatransfer_endpoint#http_port DatatransferEndpoint#http_port}
    */
    readonly httpPort?: number;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/datatransfer_endpoint#native_port DatatransferEndpoint#native_port}
    */
    readonly nativePort?: number;
    /**
    * shards block
    *
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/datatransfer_endpoint#shards DatatransferEndpoint#shards}
    */
    readonly shards?: DatatransferEndpointSettingsClickhouseTargetConnectionConnectionOptionsOnPremiseShards[] | cdktf.IResolvable;
    /**
    * tls_mode block
    *
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/datatransfer_endpoint#tls_mode DatatransferEndpoint#tls_mode}
    */
    readonly tlsMode?: DatatransferEndpointSettingsClickhouseTargetConnectionConnectionOptionsOnPremiseTlsMode;
}
export declare function datatransferEndpointSettingsClickhouseTargetConnectionConnectionOptionsOnPremiseToTerraform(struct?: DatatransferEndpointSettingsClickhouseTargetConnectionConnectionOptionsOnPremiseOutputReference | DatatransferEndpointSettingsClickhouseTargetConnectionConnectionOptionsOnPremise): any;
export declare class DatatransferEndpointSettingsClickhouseTargetConnectionConnectionOptionsOnPremiseOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DatatransferEndpointSettingsClickhouseTargetConnectionConnectionOptionsOnPremise | undefined;
    set internalValue(value: DatatransferEndpointSettingsClickhouseTargetConnectionConnectionOptionsOnPremise | undefined);
    private _httpPort?;
    get httpPort(): number;
    set httpPort(value: number);
    resetHttpPort(): void;
    get httpPortInput(): number | undefined;
    private _nativePort?;
    get nativePort(): number;
    set nativePort(value: number);
    resetNativePort(): void;
    get nativePortInput(): number | undefined;
    private _shards;
    get shards(): DatatransferEndpointSettingsClickhouseTargetConnectionConnectionOptionsOnPremiseShardsList;
    putShards(value: DatatransferEndpointSettingsClickhouseTargetConnectionConnectionOptionsOnPremiseShards[] | cdktf.IResolvable): void;
    resetShards(): void;
    get shardsInput(): cdktf.IResolvable | DatatransferEndpointSettingsClickhouseTargetConnectionConnectionOptionsOnPremiseShards[] | undefined;
    private _tlsMode;
    get tlsMode(): DatatransferEndpointSettingsClickhouseTargetConnectionConnectionOptionsOnPremiseTlsModeOutputReference;
    putTlsMode(value: DatatransferEndpointSettingsClickhouseTargetConnectionConnectionOptionsOnPremiseTlsMode): void;
    resetTlsMode(): void;
    get tlsModeInput(): DatatransferEndpointSettingsClickhouseTargetConnectionConnectionOptionsOnPremiseTlsMode | undefined;
}
export interface DatatransferEndpointSettingsClickhouseTargetConnectionConnectionOptionsPassword {
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/datatransfer_endpoint#raw DatatransferEndpoint#raw}
    */
    readonly raw?: string;
}
export declare function datatransferEndpointSettingsClickhouseTargetConnectionConnectionOptionsPasswordToTerraform(struct?: DatatransferEndpointSettingsClickhouseTargetConnectionConnectionOptionsPasswordOutputReference | DatatransferEndpointSettingsClickhouseTargetConnectionConnectionOptionsPassword): any;
export declare class DatatransferEndpointSettingsClickhouseTargetConnectionConnectionOptionsPasswordOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DatatransferEndpointSettingsClickhouseTargetConnectionConnectionOptionsPassword | undefined;
    set internalValue(value: DatatransferEndpointSettingsClickhouseTargetConnectionConnectionOptionsPassword | undefined);
    private _raw?;
    get raw(): string;
    set raw(value: string);
    resetRaw(): void;
    get rawInput(): string | undefined;
}
export interface DatatransferEndpointSettingsClickhouseTargetConnectionConnectionOptions {
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/datatransfer_endpoint#database DatatransferEndpoint#database}
    */
    readonly database?: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/datatransfer_endpoint#mdb_cluster_id DatatransferEndpoint#mdb_cluster_id}
    */
    readonly mdbClusterId?: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/datatransfer_endpoint#user DatatransferEndpoint#user}
    */
    readonly user?: string;
    /**
    * on_premise block
    *
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/datatransfer_endpoint#on_premise DatatransferEndpoint#on_premise}
    */
    readonly onPremise?: DatatransferEndpointSettingsClickhouseTargetConnectionConnectionOptionsOnPremise;
    /**
    * password block
    *
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/datatransfer_endpoint#password DatatransferEndpoint#password}
    */
    readonly password?: DatatransferEndpointSettingsClickhouseTargetConnectionConnectionOptionsPassword;
}
export declare function datatransferEndpointSettingsClickhouseTargetConnectionConnectionOptionsToTerraform(struct?: DatatransferEndpointSettingsClickhouseTargetConnectionConnectionOptionsOutputReference | DatatransferEndpointSettingsClickhouseTargetConnectionConnectionOptions): any;
export declare class DatatransferEndpointSettingsClickhouseTargetConnectionConnectionOptionsOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DatatransferEndpointSettingsClickhouseTargetConnectionConnectionOptions | undefined;
    set internalValue(value: DatatransferEndpointSettingsClickhouseTargetConnectionConnectionOptions | undefined);
    private _database?;
    get database(): string;
    set database(value: string);
    resetDatabase(): void;
    get databaseInput(): string | undefined;
    private _mdbClusterId?;
    get mdbClusterId(): string;
    set mdbClusterId(value: string);
    resetMdbClusterId(): void;
    get mdbClusterIdInput(): string | undefined;
    private _user?;
    get user(): string;
    set user(value: string);
    resetUser(): void;
    get userInput(): string | undefined;
    private _onPremise;
    get onPremise(): DatatransferEndpointSettingsClickhouseTargetConnectionConnectionOptionsOnPremiseOutputReference;
    putOnPremise(value: DatatransferEndpointSettingsClickhouseTargetConnectionConnectionOptionsOnPremise): void;
    resetOnPremise(): void;
    get onPremiseInput(): DatatransferEndpointSettingsClickhouseTargetConnectionConnectionOptionsOnPremise | undefined;
    private _password;
    get password(): DatatransferEndpointSettingsClickhouseTargetConnectionConnectionOptionsPasswordOutputReference;
    putPassword(value: DatatransferEndpointSettingsClickhouseTargetConnectionConnectionOptionsPassword): void;
    resetPassword(): void;
    get passwordInput(): DatatransferEndpointSettingsClickhouseTargetConnectionConnectionOptionsPassword | undefined;
}
export interface DatatransferEndpointSettingsClickhouseTargetConnection {
    /**
    * connection_options block
    *
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/datatransfer_endpoint#connection_options DatatransferEndpoint#connection_options}
    */
    readonly connectionOptions?: DatatransferEndpointSettingsClickhouseTargetConnectionConnectionOptions;
}
export declare function datatransferEndpointSettingsClickhouseTargetConnectionToTerraform(struct?: DatatransferEndpointSettingsClickhouseTargetConnectionOutputReference | DatatransferEndpointSettingsClickhouseTargetConnection): any;
export declare class DatatransferEndpointSettingsClickhouseTargetConnectionOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DatatransferEndpointSettingsClickhouseTargetConnection | undefined;
    set internalValue(value: DatatransferEndpointSettingsClickhouseTargetConnection | undefined);
    private _connectionOptions;
    get connectionOptions(): DatatransferEndpointSettingsClickhouseTargetConnectionConnectionOptionsOutputReference;
    putConnectionOptions(value: DatatransferEndpointSettingsClickhouseTargetConnectionConnectionOptions): void;
    resetConnectionOptions(): void;
    get connectionOptionsInput(): DatatransferEndpointSettingsClickhouseTargetConnectionConnectionOptions | undefined;
}
export interface DatatransferEndpointSettingsClickhouseTargetShardingColumnValueHash {
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/datatransfer_endpoint#column_name DatatransferEndpoint#column_name}
    */
    readonly columnName?: string;
}
export declare function datatransferEndpointSettingsClickhouseTargetShardingColumnValueHashToTerraform(struct?: DatatransferEndpointSettingsClickhouseTargetShardingColumnValueHashOutputReference | DatatransferEndpointSettingsClickhouseTargetShardingColumnValueHash): any;
export declare class DatatransferEndpointSettingsClickhouseTargetShardingColumnValueHashOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DatatransferEndpointSettingsClickhouseTargetShardingColumnValueHash | undefined;
    set internalValue(value: DatatransferEndpointSettingsClickhouseTargetShardingColumnValueHash | undefined);
    private _columnName?;
    get columnName(): string;
    set columnName(value: string);
    resetColumnName(): void;
    get columnNameInput(): string | undefined;
}
export interface DatatransferEndpointSettingsClickhouseTargetShardingTransferId {
}
export declare function datatransferEndpointSettingsClickhouseTargetShardingTransferIdToTerraform(struct?: DatatransferEndpointSettingsClickhouseTargetShardingTransferIdOutputReference | DatatransferEndpointSettingsClickhouseTargetShardingTransferId): any;
export declare class DatatransferEndpointSettingsClickhouseTargetShardingTransferIdOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DatatransferEndpointSettingsClickhouseTargetShardingTransferId | undefined;
    set internalValue(value: DatatransferEndpointSettingsClickhouseTargetShardingTransferId | undefined);
}
export interface DatatransferEndpointSettingsClickhouseTargetSharding {
    /**
    * column_value_hash block
    *
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/datatransfer_endpoint#column_value_hash DatatransferEndpoint#column_value_hash}
    */
    readonly columnValueHash?: DatatransferEndpointSettingsClickhouseTargetShardingColumnValueHash;
    /**
    * transfer_id block
    *
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/datatransfer_endpoint#transfer_id DatatransferEndpoint#transfer_id}
    */
    readonly transferId?: DatatransferEndpointSettingsClickhouseTargetShardingTransferId;
}
export declare function datatransferEndpointSettingsClickhouseTargetShardingToTerraform(struct?: DatatransferEndpointSettingsClickhouseTargetShardingOutputReference | DatatransferEndpointSettingsClickhouseTargetSharding): any;
export declare class DatatransferEndpointSettingsClickhouseTargetShardingOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DatatransferEndpointSettingsClickhouseTargetSharding | undefined;
    set internalValue(value: DatatransferEndpointSettingsClickhouseTargetSharding | undefined);
    private _columnValueHash;
    get columnValueHash(): DatatransferEndpointSettingsClickhouseTargetShardingColumnValueHashOutputReference;
    putColumnValueHash(value: DatatransferEndpointSettingsClickhouseTargetShardingColumnValueHash): void;
    resetColumnValueHash(): void;
    get columnValueHashInput(): DatatransferEndpointSettingsClickhouseTargetShardingColumnValueHash | undefined;
    private _transferId;
    get transferId(): DatatransferEndpointSettingsClickhouseTargetShardingTransferIdOutputReference;
    putTransferId(value: DatatransferEndpointSettingsClickhouseTargetShardingTransferId): void;
    resetTransferId(): void;
    get transferIdInput(): DatatransferEndpointSettingsClickhouseTargetShardingTransferId | undefined;
}
export interface DatatransferEndpointSettingsClickhouseTarget {
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/datatransfer_endpoint#cleanup_policy DatatransferEndpoint#cleanup_policy}
    */
    readonly cleanupPolicy?: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/datatransfer_endpoint#clickhouse_cluster_name DatatransferEndpoint#clickhouse_cluster_name}
    */
    readonly clickhouseClusterName?: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/datatransfer_endpoint#security_groups DatatransferEndpoint#security_groups}
    */
    readonly securityGroups?: string[];
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/datatransfer_endpoint#subnet_id DatatransferEndpoint#subnet_id}
    */
    readonly subnetId?: string;
    /**
    * alt_names block
    *
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/datatransfer_endpoint#alt_names DatatransferEndpoint#alt_names}
    */
    readonly altNames?: DatatransferEndpointSettingsClickhouseTargetAltNames[] | cdktf.IResolvable;
    /**
    * connection block
    *
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/datatransfer_endpoint#connection DatatransferEndpoint#connection}
    */
    readonly connection?: DatatransferEndpointSettingsClickhouseTargetConnection;
    /**
    * sharding block
    *
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/datatransfer_endpoint#sharding DatatransferEndpoint#sharding}
    */
    readonly sharding?: DatatransferEndpointSettingsClickhouseTargetSharding;
}
export declare function datatransferEndpointSettingsClickhouseTargetToTerraform(struct?: DatatransferEndpointSettingsClickhouseTargetOutputReference | DatatransferEndpointSettingsClickhouseTarget): any;
export declare class DatatransferEndpointSettingsClickhouseTargetOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DatatransferEndpointSettingsClickhouseTarget | undefined;
    set internalValue(value: DatatransferEndpointSettingsClickhouseTarget | undefined);
    private _cleanupPolicy?;
    get cleanupPolicy(): string;
    set cleanupPolicy(value: string);
    resetCleanupPolicy(): void;
    get cleanupPolicyInput(): string | undefined;
    private _clickhouseClusterName?;
    get clickhouseClusterName(): string;
    set clickhouseClusterName(value: string);
    resetClickhouseClusterName(): void;
    get clickhouseClusterNameInput(): string | undefined;
    private _securityGroups?;
    get securityGroups(): string[];
    set securityGroups(value: string[]);
    resetSecurityGroups(): void;
    get securityGroupsInput(): string[] | undefined;
    private _subnetId?;
    get subnetId(): string;
    set subnetId(value: string);
    resetSubnetId(): void;
    get subnetIdInput(): string | undefined;
    private _altNames;
    get altNames(): DatatransferEndpointSettingsClickhouseTargetAltNamesList;
    putAltNames(value: DatatransferEndpointSettingsClickhouseTargetAltNames[] | cdktf.IResolvable): void;
    resetAltNames(): void;
    get altNamesInput(): cdktf.IResolvable | DatatransferEndpointSettingsClickhouseTargetAltNames[] | undefined;
    private _connection;
    get connection(): DatatransferEndpointSettingsClickhouseTargetConnectionOutputReference;
    putConnection(value: DatatransferEndpointSettingsClickhouseTargetConnection): void;
    resetConnection(): void;
    get connectionInput(): DatatransferEndpointSettingsClickhouseTargetConnection | undefined;
    private _sharding;
    get sharding(): DatatransferEndpointSettingsClickhouseTargetShardingOutputReference;
    putSharding(value: DatatransferEndpointSettingsClickhouseTargetSharding): void;
    resetSharding(): void;
    get shardingInput(): DatatransferEndpointSettingsClickhouseTargetSharding | undefined;
}
export interface DatatransferEndpointSettingsMongoSourceCollections {
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/datatransfer_endpoint#collection_name DatatransferEndpoint#collection_name}
    */
    readonly collectionName?: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/datatransfer_endpoint#database_name DatatransferEndpoint#database_name}
    */
    readonly databaseName?: string;
}
export declare function datatransferEndpointSettingsMongoSourceCollectionsToTerraform(struct?: DatatransferEndpointSettingsMongoSourceCollections | cdktf.IResolvable): any;
export declare class DatatransferEndpointSettingsMongoSourceCollectionsOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DatatransferEndpointSettingsMongoSourceCollections | cdktf.IResolvable | undefined;
    set internalValue(value: DatatransferEndpointSettingsMongoSourceCollections | cdktf.IResolvable | undefined);
    private _collectionName?;
    get collectionName(): string;
    set collectionName(value: string);
    resetCollectionName(): void;
    get collectionNameInput(): string | undefined;
    private _databaseName?;
    get databaseName(): string;
    set databaseName(value: string);
    resetDatabaseName(): void;
    get databaseNameInput(): string | undefined;
}
export declare class DatatransferEndpointSettingsMongoSourceCollectionsList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DatatransferEndpointSettingsMongoSourceCollections[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DatatransferEndpointSettingsMongoSourceCollectionsOutputReference;
}
export interface DatatransferEndpointSettingsMongoSourceConnectionConnectionOptionsOnPremiseTlsModeDisabled {
}
export declare function datatransferEndpointSettingsMongoSourceConnectionConnectionOptionsOnPremiseTlsModeDisabledToTerraform(struct?: DatatransferEndpointSettingsMongoSourceConnectionConnectionOptionsOnPremiseTlsModeDisabledOutputReference | DatatransferEndpointSettingsMongoSourceConnectionConnectionOptionsOnPremiseTlsModeDisabled): any;
export declare class DatatransferEndpointSettingsMongoSourceConnectionConnectionOptionsOnPremiseTlsModeDisabledOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DatatransferEndpointSettingsMongoSourceConnectionConnectionOptionsOnPremiseTlsModeDisabled | undefined;
    set internalValue(value: DatatransferEndpointSettingsMongoSourceConnectionConnectionOptionsOnPremiseTlsModeDisabled | undefined);
}
export interface DatatransferEndpointSettingsMongoSourceConnectionConnectionOptionsOnPremiseTlsModeEnabled {
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/datatransfer_endpoint#ca_certificate DatatransferEndpoint#ca_certificate}
    */
    readonly caCertificate?: string;
}
export declare function datatransferEndpointSettingsMongoSourceConnectionConnectionOptionsOnPremiseTlsModeEnabledToTerraform(struct?: DatatransferEndpointSettingsMongoSourceConnectionConnectionOptionsOnPremiseTlsModeEnabledOutputReference | DatatransferEndpointSettingsMongoSourceConnectionConnectionOptionsOnPremiseTlsModeEnabled): any;
export declare class DatatransferEndpointSettingsMongoSourceConnectionConnectionOptionsOnPremiseTlsModeEnabledOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DatatransferEndpointSettingsMongoSourceConnectionConnectionOptionsOnPremiseTlsModeEnabled | undefined;
    set internalValue(value: DatatransferEndpointSettingsMongoSourceConnectionConnectionOptionsOnPremiseTlsModeEnabled | undefined);
    private _caCertificate?;
    get caCertificate(): string;
    set caCertificate(value: string);
    resetCaCertificate(): void;
    get caCertificateInput(): string | undefined;
}
export interface DatatransferEndpointSettingsMongoSourceConnectionConnectionOptionsOnPremiseTlsMode {
    /**
    * disabled block
    *
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/datatransfer_endpoint#disabled DatatransferEndpoint#disabled}
    */
    readonly disabled?: DatatransferEndpointSettingsMongoSourceConnectionConnectionOptionsOnPremiseTlsModeDisabled;
    /**
    * enabled block
    *
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/datatransfer_endpoint#enabled DatatransferEndpoint#enabled}
    */
    readonly enabled?: DatatransferEndpointSettingsMongoSourceConnectionConnectionOptionsOnPremiseTlsModeEnabled;
}
export declare function datatransferEndpointSettingsMongoSourceConnectionConnectionOptionsOnPremiseTlsModeToTerraform(struct?: DatatransferEndpointSettingsMongoSourceConnectionConnectionOptionsOnPremiseTlsModeOutputReference | DatatransferEndpointSettingsMongoSourceConnectionConnectionOptionsOnPremiseTlsMode): any;
export declare class DatatransferEndpointSettingsMongoSourceConnectionConnectionOptionsOnPremiseTlsModeOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DatatransferEndpointSettingsMongoSourceConnectionConnectionOptionsOnPremiseTlsMode | undefined;
    set internalValue(value: DatatransferEndpointSettingsMongoSourceConnectionConnectionOptionsOnPremiseTlsMode | undefined);
    private _disabled;
    get disabled(): DatatransferEndpointSettingsMongoSourceConnectionConnectionOptionsOnPremiseTlsModeDisabledOutputReference;
    putDisabled(value: DatatransferEndpointSettingsMongoSourceConnectionConnectionOptionsOnPremiseTlsModeDisabled): void;
    resetDisabled(): void;
    get disabledInput(): DatatransferEndpointSettingsMongoSourceConnectionConnectionOptionsOnPremiseTlsModeDisabled | undefined;
    private _enabled;
    get enabled(): DatatransferEndpointSettingsMongoSourceConnectionConnectionOptionsOnPremiseTlsModeEnabledOutputReference;
    putEnabled(value: DatatransferEndpointSettingsMongoSourceConnectionConnectionOptionsOnPremiseTlsModeEnabled): void;
    resetEnabled(): void;
    get enabledInput(): DatatransferEndpointSettingsMongoSourceConnectionConnectionOptionsOnPremiseTlsModeEnabled | undefined;
}
export interface DatatransferEndpointSettingsMongoSourceConnectionConnectionOptionsOnPremise {
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/datatransfer_endpoint#hosts DatatransferEndpoint#hosts}
    */
    readonly hosts?: string[];
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/datatransfer_endpoint#port DatatransferEndpoint#port}
    */
    readonly port?: number;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/datatransfer_endpoint#replica_set DatatransferEndpoint#replica_set}
    */
    readonly replicaSet?: string;
    /**
    * tls_mode block
    *
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/datatransfer_endpoint#tls_mode DatatransferEndpoint#tls_mode}
    */
    readonly tlsMode?: DatatransferEndpointSettingsMongoSourceConnectionConnectionOptionsOnPremiseTlsMode;
}
export declare function datatransferEndpointSettingsMongoSourceConnectionConnectionOptionsOnPremiseToTerraform(struct?: DatatransferEndpointSettingsMongoSourceConnectionConnectionOptionsOnPremiseOutputReference | DatatransferEndpointSettingsMongoSourceConnectionConnectionOptionsOnPremise): any;
export declare class DatatransferEndpointSettingsMongoSourceConnectionConnectionOptionsOnPremiseOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DatatransferEndpointSettingsMongoSourceConnectionConnectionOptionsOnPremise | undefined;
    set internalValue(value: DatatransferEndpointSettingsMongoSourceConnectionConnectionOptionsOnPremise | undefined);
    private _hosts?;
    get hosts(): string[];
    set hosts(value: string[]);
    resetHosts(): void;
    get hostsInput(): string[] | undefined;
    private _port?;
    get port(): number;
    set port(value: number);
    resetPort(): void;
    get portInput(): number | undefined;
    private _replicaSet?;
    get replicaSet(): string;
    set replicaSet(value: string);
    resetReplicaSet(): void;
    get replicaSetInput(): string | undefined;
    private _tlsMode;
    get tlsMode(): DatatransferEndpointSettingsMongoSourceConnectionConnectionOptionsOnPremiseTlsModeOutputReference;
    putTlsMode(value: DatatransferEndpointSettingsMongoSourceConnectionConnectionOptionsOnPremiseTlsMode): void;
    resetTlsMode(): void;
    get tlsModeInput(): DatatransferEndpointSettingsMongoSourceConnectionConnectionOptionsOnPremiseTlsMode | undefined;
}
export interface DatatransferEndpointSettingsMongoSourceConnectionConnectionOptionsPassword {
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/datatransfer_endpoint#raw DatatransferEndpoint#raw}
    */
    readonly raw?: string;
}
export declare function datatransferEndpointSettingsMongoSourceConnectionConnectionOptionsPasswordToTerraform(struct?: DatatransferEndpointSettingsMongoSourceConnectionConnectionOptionsPasswordOutputReference | DatatransferEndpointSettingsMongoSourceConnectionConnectionOptionsPassword): any;
export declare class DatatransferEndpointSettingsMongoSourceConnectionConnectionOptionsPasswordOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DatatransferEndpointSettingsMongoSourceConnectionConnectionOptionsPassword | undefined;
    set internalValue(value: DatatransferEndpointSettingsMongoSourceConnectionConnectionOptionsPassword | undefined);
    private _raw?;
    get raw(): string;
    set raw(value: string);
    resetRaw(): void;
    get rawInput(): string | undefined;
}
export interface DatatransferEndpointSettingsMongoSourceConnectionConnectionOptions {
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/datatransfer_endpoint#auth_source DatatransferEndpoint#auth_source}
    */
    readonly authSource?: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/datatransfer_endpoint#mdb_cluster_id DatatransferEndpoint#mdb_cluster_id}
    */
    readonly mdbClusterId?: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/datatransfer_endpoint#user DatatransferEndpoint#user}
    */
    readonly user?: string;
    /**
    * on_premise block
    *
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/datatransfer_endpoint#on_premise DatatransferEndpoint#on_premise}
    */
    readonly onPremise?: DatatransferEndpointSettingsMongoSourceConnectionConnectionOptionsOnPremise;
    /**
    * password block
    *
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/datatransfer_endpoint#password DatatransferEndpoint#password}
    */
    readonly password?: DatatransferEndpointSettingsMongoSourceConnectionConnectionOptionsPassword;
}
export declare function datatransferEndpointSettingsMongoSourceConnectionConnectionOptionsToTerraform(struct?: DatatransferEndpointSettingsMongoSourceConnectionConnectionOptionsOutputReference | DatatransferEndpointSettingsMongoSourceConnectionConnectionOptions): any;
export declare class DatatransferEndpointSettingsMongoSourceConnectionConnectionOptionsOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DatatransferEndpointSettingsMongoSourceConnectionConnectionOptions | undefined;
    set internalValue(value: DatatransferEndpointSettingsMongoSourceConnectionConnectionOptions | undefined);
    private _authSource?;
    get authSource(): string;
    set authSource(value: string);
    resetAuthSource(): void;
    get authSourceInput(): string | undefined;
    private _mdbClusterId?;
    get mdbClusterId(): string;
    set mdbClusterId(value: string);
    resetMdbClusterId(): void;
    get mdbClusterIdInput(): string | undefined;
    private _user?;
    get user(): string;
    set user(value: string);
    resetUser(): void;
    get userInput(): string | undefined;
    private _onPremise;
    get onPremise(): DatatransferEndpointSettingsMongoSourceConnectionConnectionOptionsOnPremiseOutputReference;
    putOnPremise(value: DatatransferEndpointSettingsMongoSourceConnectionConnectionOptionsOnPremise): void;
    resetOnPremise(): void;
    get onPremiseInput(): DatatransferEndpointSettingsMongoSourceConnectionConnectionOptionsOnPremise | undefined;
    private _password;
    get password(): DatatransferEndpointSettingsMongoSourceConnectionConnectionOptionsPasswordOutputReference;
    putPassword(value: DatatransferEndpointSettingsMongoSourceConnectionConnectionOptionsPassword): void;
    resetPassword(): void;
    get passwordInput(): DatatransferEndpointSettingsMongoSourceConnectionConnectionOptionsPassword | undefined;
}
export interface DatatransferEndpointSettingsMongoSourceConnection {
    /**
    * connection_options block
    *
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/datatransfer_endpoint#connection_options DatatransferEndpoint#connection_options}
    */
    readonly connectionOptions?: DatatransferEndpointSettingsMongoSourceConnectionConnectionOptions;
}
export declare function datatransferEndpointSettingsMongoSourceConnectionToTerraform(struct?: DatatransferEndpointSettingsMongoSourceConnectionOutputReference | DatatransferEndpointSettingsMongoSourceConnection): any;
export declare class DatatransferEndpointSettingsMongoSourceConnectionOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DatatransferEndpointSettingsMongoSourceConnection | undefined;
    set internalValue(value: DatatransferEndpointSettingsMongoSourceConnection | undefined);
    private _connectionOptions;
    get connectionOptions(): DatatransferEndpointSettingsMongoSourceConnectionConnectionOptionsOutputReference;
    putConnectionOptions(value: DatatransferEndpointSettingsMongoSourceConnectionConnectionOptions): void;
    resetConnectionOptions(): void;
    get connectionOptionsInput(): DatatransferEndpointSettingsMongoSourceConnectionConnectionOptions | undefined;
}
export interface DatatransferEndpointSettingsMongoSourceExcludedCollections {
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/datatransfer_endpoint#collection_name DatatransferEndpoint#collection_name}
    */
    readonly collectionName?: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/datatransfer_endpoint#database_name DatatransferEndpoint#database_name}
    */
    readonly databaseName?: string;
}
export declare function datatransferEndpointSettingsMongoSourceExcludedCollectionsToTerraform(struct?: DatatransferEndpointSettingsMongoSourceExcludedCollections | cdktf.IResolvable): any;
export declare class DatatransferEndpointSettingsMongoSourceExcludedCollectionsOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DatatransferEndpointSettingsMongoSourceExcludedCollections | cdktf.IResolvable | undefined;
    set internalValue(value: DatatransferEndpointSettingsMongoSourceExcludedCollections | cdktf.IResolvable | undefined);
    private _collectionName?;
    get collectionName(): string;
    set collectionName(value: string);
    resetCollectionName(): void;
    get collectionNameInput(): string | undefined;
    private _databaseName?;
    get databaseName(): string;
    set databaseName(value: string);
    resetDatabaseName(): void;
    get databaseNameInput(): string | undefined;
}
export declare class DatatransferEndpointSettingsMongoSourceExcludedCollectionsList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DatatransferEndpointSettingsMongoSourceExcludedCollections[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DatatransferEndpointSettingsMongoSourceExcludedCollectionsOutputReference;
}
export interface DatatransferEndpointSettingsMongoSource {
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/datatransfer_endpoint#secondary_preferred_mode DatatransferEndpoint#secondary_preferred_mode}
    */
    readonly secondaryPreferredMode?: boolean | cdktf.IResolvable;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/datatransfer_endpoint#security_groups DatatransferEndpoint#security_groups}
    */
    readonly securityGroups?: string[];
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/datatransfer_endpoint#subnet_id DatatransferEndpoint#subnet_id}
    */
    readonly subnetId?: string;
    /**
    * collections block
    *
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/datatransfer_endpoint#collections DatatransferEndpoint#collections}
    */
    readonly collections?: DatatransferEndpointSettingsMongoSourceCollections[] | cdktf.IResolvable;
    /**
    * connection block
    *
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/datatransfer_endpoint#connection DatatransferEndpoint#connection}
    */
    readonly connection?: DatatransferEndpointSettingsMongoSourceConnection;
    /**
    * excluded_collections block
    *
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/datatransfer_endpoint#excluded_collections DatatransferEndpoint#excluded_collections}
    */
    readonly excludedCollections?: DatatransferEndpointSettingsMongoSourceExcludedCollections[] | cdktf.IResolvable;
}
export declare function datatransferEndpointSettingsMongoSourceToTerraform(struct?: DatatransferEndpointSettingsMongoSourceOutputReference | DatatransferEndpointSettingsMongoSource): any;
export declare class DatatransferEndpointSettingsMongoSourceOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DatatransferEndpointSettingsMongoSource | undefined;
    set internalValue(value: DatatransferEndpointSettingsMongoSource | undefined);
    private _secondaryPreferredMode?;
    get secondaryPreferredMode(): boolean | cdktf.IResolvable;
    set secondaryPreferredMode(value: boolean | cdktf.IResolvable);
    resetSecondaryPreferredMode(): void;
    get secondaryPreferredModeInput(): boolean | cdktf.IResolvable | undefined;
    private _securityGroups?;
    get securityGroups(): string[];
    set securityGroups(value: string[]);
    resetSecurityGroups(): void;
    get securityGroupsInput(): string[] | undefined;
    private _subnetId?;
    get subnetId(): string;
    set subnetId(value: string);
    resetSubnetId(): void;
    get subnetIdInput(): string | undefined;
    private _collections;
    get collections(): DatatransferEndpointSettingsMongoSourceCollectionsList;
    putCollections(value: DatatransferEndpointSettingsMongoSourceCollections[] | cdktf.IResolvable): void;
    resetCollections(): void;
    get collectionsInput(): cdktf.IResolvable | DatatransferEndpointSettingsMongoSourceCollections[] | undefined;
    private _connection;
    get connection(): DatatransferEndpointSettingsMongoSourceConnectionOutputReference;
    putConnection(value: DatatransferEndpointSettingsMongoSourceConnection): void;
    resetConnection(): void;
    get connectionInput(): DatatransferEndpointSettingsMongoSourceConnection | undefined;
    private _excludedCollections;
    get excludedCollections(): DatatransferEndpointSettingsMongoSourceExcludedCollectionsList;
    putExcludedCollections(value: DatatransferEndpointSettingsMongoSourceExcludedCollections[] | cdktf.IResolvable): void;
    resetExcludedCollections(): void;
    get excludedCollectionsInput(): cdktf.IResolvable | DatatransferEndpointSettingsMongoSourceExcludedCollections[] | undefined;
}
export interface DatatransferEndpointSettingsMongoTargetConnectionConnectionOptionsOnPremiseTlsModeDisabled {
}
export declare function datatransferEndpointSettingsMongoTargetConnectionConnectionOptionsOnPremiseTlsModeDisabledToTerraform(struct?: DatatransferEndpointSettingsMongoTargetConnectionConnectionOptionsOnPremiseTlsModeDisabledOutputReference | DatatransferEndpointSettingsMongoTargetConnectionConnectionOptionsOnPremiseTlsModeDisabled): any;
export declare class DatatransferEndpointSettingsMongoTargetConnectionConnectionOptionsOnPremiseTlsModeDisabledOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DatatransferEndpointSettingsMongoTargetConnectionConnectionOptionsOnPremiseTlsModeDisabled | undefined;
    set internalValue(value: DatatransferEndpointSettingsMongoTargetConnectionConnectionOptionsOnPremiseTlsModeDisabled | undefined);
}
export interface DatatransferEndpointSettingsMongoTargetConnectionConnectionOptionsOnPremiseTlsModeEnabled {
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/datatransfer_endpoint#ca_certificate DatatransferEndpoint#ca_certificate}
    */
    readonly caCertificate?: string;
}
export declare function datatransferEndpointSettingsMongoTargetConnectionConnectionOptionsOnPremiseTlsModeEnabledToTerraform(struct?: DatatransferEndpointSettingsMongoTargetConnectionConnectionOptionsOnPremiseTlsModeEnabledOutputReference | DatatransferEndpointSettingsMongoTargetConnectionConnectionOptionsOnPremiseTlsModeEnabled): any;
export declare class DatatransferEndpointSettingsMongoTargetConnectionConnectionOptionsOnPremiseTlsModeEnabledOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DatatransferEndpointSettingsMongoTargetConnectionConnectionOptionsOnPremiseTlsModeEnabled | undefined;
    set internalValue(value: DatatransferEndpointSettingsMongoTargetConnectionConnectionOptionsOnPremiseTlsModeEnabled | undefined);
    private _caCertificate?;
    get caCertificate(): string;
    set caCertificate(value: string);
    resetCaCertificate(): void;
    get caCertificateInput(): string | undefined;
}
export interface DatatransferEndpointSettingsMongoTargetConnectionConnectionOptionsOnPremiseTlsMode {
    /**
    * disabled block
    *
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/datatransfer_endpoint#disabled DatatransferEndpoint#disabled}
    */
    readonly disabled?: DatatransferEndpointSettingsMongoTargetConnectionConnectionOptionsOnPremiseTlsModeDisabled;
    /**
    * enabled block
    *
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/datatransfer_endpoint#enabled DatatransferEndpoint#enabled}
    */
    readonly enabled?: DatatransferEndpointSettingsMongoTargetConnectionConnectionOptionsOnPremiseTlsModeEnabled;
}
export declare function datatransferEndpointSettingsMongoTargetConnectionConnectionOptionsOnPremiseTlsModeToTerraform(struct?: DatatransferEndpointSettingsMongoTargetConnectionConnectionOptionsOnPremiseTlsModeOutputReference | DatatransferEndpointSettingsMongoTargetConnectionConnectionOptionsOnPremiseTlsMode): any;
export declare class DatatransferEndpointSettingsMongoTargetConnectionConnectionOptionsOnPremiseTlsModeOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DatatransferEndpointSettingsMongoTargetConnectionConnectionOptionsOnPremiseTlsMode | undefined;
    set internalValue(value: DatatransferEndpointSettingsMongoTargetConnectionConnectionOptionsOnPremiseTlsMode | undefined);
    private _disabled;
    get disabled(): DatatransferEndpointSettingsMongoTargetConnectionConnectionOptionsOnPremiseTlsModeDisabledOutputReference;
    putDisabled(value: DatatransferEndpointSettingsMongoTargetConnectionConnectionOptionsOnPremiseTlsModeDisabled): void;
    resetDisabled(): void;
    get disabledInput(): DatatransferEndpointSettingsMongoTargetConnectionConnectionOptionsOnPremiseTlsModeDisabled | undefined;
    private _enabled;
    get enabled(): DatatransferEndpointSettingsMongoTargetConnectionConnectionOptionsOnPremiseTlsModeEnabledOutputReference;
    putEnabled(value: DatatransferEndpointSettingsMongoTargetConnectionConnectionOptionsOnPremiseTlsModeEnabled): void;
    resetEnabled(): void;
    get enabledInput(): DatatransferEndpointSettingsMongoTargetConnectionConnectionOptionsOnPremiseTlsModeEnabled | undefined;
}
export interface DatatransferEndpointSettingsMongoTargetConnectionConnectionOptionsOnPremise {
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/datatransfer_endpoint#hosts DatatransferEndpoint#hosts}
    */
    readonly hosts?: string[];
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/datatransfer_endpoint#port DatatransferEndpoint#port}
    */
    readonly port?: number;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/datatransfer_endpoint#replica_set DatatransferEndpoint#replica_set}
    */
    readonly replicaSet?: string;
    /**
    * tls_mode block
    *
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/datatransfer_endpoint#tls_mode DatatransferEndpoint#tls_mode}
    */
    readonly tlsMode?: DatatransferEndpointSettingsMongoTargetConnectionConnectionOptionsOnPremiseTlsMode;
}
export declare function datatransferEndpointSettingsMongoTargetConnectionConnectionOptionsOnPremiseToTerraform(struct?: DatatransferEndpointSettingsMongoTargetConnectionConnectionOptionsOnPremiseOutputReference | DatatransferEndpointSettingsMongoTargetConnectionConnectionOptionsOnPremise): any;
export declare class DatatransferEndpointSettingsMongoTargetConnectionConnectionOptionsOnPremiseOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DatatransferEndpointSettingsMongoTargetConnectionConnectionOptionsOnPremise | undefined;
    set internalValue(value: DatatransferEndpointSettingsMongoTargetConnectionConnectionOptionsOnPremise | undefined);
    private _hosts?;
    get hosts(): string[];
    set hosts(value: string[]);
    resetHosts(): void;
    get hostsInput(): string[] | undefined;
    private _port?;
    get port(): number;
    set port(value: number);
    resetPort(): void;
    get portInput(): number | undefined;
    private _replicaSet?;
    get replicaSet(): string;
    set replicaSet(value: string);
    resetReplicaSet(): void;
    get replicaSetInput(): string | undefined;
    private _tlsMode;
    get tlsMode(): DatatransferEndpointSettingsMongoTargetConnectionConnectionOptionsOnPremiseTlsModeOutputReference;
    putTlsMode(value: DatatransferEndpointSettingsMongoTargetConnectionConnectionOptionsOnPremiseTlsMode): void;
    resetTlsMode(): void;
    get tlsModeInput(): DatatransferEndpointSettingsMongoTargetConnectionConnectionOptionsOnPremiseTlsMode | undefined;
}
export interface DatatransferEndpointSettingsMongoTargetConnectionConnectionOptionsPassword {
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/datatransfer_endpoint#raw DatatransferEndpoint#raw}
    */
    readonly raw?: string;
}
export declare function datatransferEndpointSettingsMongoTargetConnectionConnectionOptionsPasswordToTerraform(struct?: DatatransferEndpointSettingsMongoTargetConnectionConnectionOptionsPasswordOutputReference | DatatransferEndpointSettingsMongoTargetConnectionConnectionOptionsPassword): any;
export declare class DatatransferEndpointSettingsMongoTargetConnectionConnectionOptionsPasswordOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DatatransferEndpointSettingsMongoTargetConnectionConnectionOptionsPassword | undefined;
    set internalValue(value: DatatransferEndpointSettingsMongoTargetConnectionConnectionOptionsPassword | undefined);
    private _raw?;
    get raw(): string;
    set raw(value: string);
    resetRaw(): void;
    get rawInput(): string | undefined;
}
export interface DatatransferEndpointSettingsMongoTargetConnectionConnectionOptions {
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/datatransfer_endpoint#auth_source DatatransferEndpoint#auth_source}
    */
    readonly authSource?: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/datatransfer_endpoint#mdb_cluster_id DatatransferEndpoint#mdb_cluster_id}
    */
    readonly mdbClusterId?: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/datatransfer_endpoint#user DatatransferEndpoint#user}
    */
    readonly user?: string;
    /**
    * on_premise block
    *
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/datatransfer_endpoint#on_premise DatatransferEndpoint#on_premise}
    */
    readonly onPremise?: DatatransferEndpointSettingsMongoTargetConnectionConnectionOptionsOnPremise;
    /**
    * password block
    *
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/datatransfer_endpoint#password DatatransferEndpoint#password}
    */
    readonly password?: DatatransferEndpointSettingsMongoTargetConnectionConnectionOptionsPassword;
}
export declare function datatransferEndpointSettingsMongoTargetConnectionConnectionOptionsToTerraform(struct?: DatatransferEndpointSettingsMongoTargetConnectionConnectionOptionsOutputReference | DatatransferEndpointSettingsMongoTargetConnectionConnectionOptions): any;
export declare class DatatransferEndpointSettingsMongoTargetConnectionConnectionOptionsOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DatatransferEndpointSettingsMongoTargetConnectionConnectionOptions | undefined;
    set internalValue(value: DatatransferEndpointSettingsMongoTargetConnectionConnectionOptions | undefined);
    private _authSource?;
    get authSource(): string;
    set authSource(value: string);
    resetAuthSource(): void;
    get authSourceInput(): string | undefined;
    private _mdbClusterId?;
    get mdbClusterId(): string;
    set mdbClusterId(value: string);
    resetMdbClusterId(): void;
    get mdbClusterIdInput(): string | undefined;
    private _user?;
    get user(): string;
    set user(value: string);
    resetUser(): void;
    get userInput(): string | undefined;
    private _onPremise;
    get onPremise(): DatatransferEndpointSettingsMongoTargetConnectionConnectionOptionsOnPremiseOutputReference;
    putOnPremise(value: DatatransferEndpointSettingsMongoTargetConnectionConnectionOptionsOnPremise): void;
    resetOnPremise(): void;
    get onPremiseInput(): DatatransferEndpointSettingsMongoTargetConnectionConnectionOptionsOnPremise | undefined;
    private _password;
    get password(): DatatransferEndpointSettingsMongoTargetConnectionConnectionOptionsPasswordOutputReference;
    putPassword(value: DatatransferEndpointSettingsMongoTargetConnectionConnectionOptionsPassword): void;
    resetPassword(): void;
    get passwordInput(): DatatransferEndpointSettingsMongoTargetConnectionConnectionOptionsPassword | undefined;
}
export interface DatatransferEndpointSettingsMongoTargetConnection {
    /**
    * connection_options block
    *
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/datatransfer_endpoint#connection_options DatatransferEndpoint#connection_options}
    */
    readonly connectionOptions?: DatatransferEndpointSettingsMongoTargetConnectionConnectionOptions;
}
export declare function datatransferEndpointSettingsMongoTargetConnectionToTerraform(struct?: DatatransferEndpointSettingsMongoTargetConnectionOutputReference | DatatransferEndpointSettingsMongoTargetConnection): any;
export declare class DatatransferEndpointSettingsMongoTargetConnectionOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DatatransferEndpointSettingsMongoTargetConnection | undefined;
    set internalValue(value: DatatransferEndpointSettingsMongoTargetConnection | undefined);
    private _connectionOptions;
    get connectionOptions(): DatatransferEndpointSettingsMongoTargetConnectionConnectionOptionsOutputReference;
    putConnectionOptions(value: DatatransferEndpointSettingsMongoTargetConnectionConnectionOptions): void;
    resetConnectionOptions(): void;
    get connectionOptionsInput(): DatatransferEndpointSettingsMongoTargetConnectionConnectionOptions | undefined;
}
export interface DatatransferEndpointSettingsMongoTarget {
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/datatransfer_endpoint#cleanup_policy DatatransferEndpoint#cleanup_policy}
    */
    readonly cleanupPolicy?: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/datatransfer_endpoint#database DatatransferEndpoint#database}
    */
    readonly database?: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/datatransfer_endpoint#security_groups DatatransferEndpoint#security_groups}
    */
    readonly securityGroups?: string[];
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/datatransfer_endpoint#subnet_id DatatransferEndpoint#subnet_id}
    */
    readonly subnetId?: string;
    /**
    * connection block
    *
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/datatransfer_endpoint#connection DatatransferEndpoint#connection}
    */
    readonly connection?: DatatransferEndpointSettingsMongoTargetConnection;
}
export declare function datatransferEndpointSettingsMongoTargetToTerraform(struct?: DatatransferEndpointSettingsMongoTargetOutputReference | DatatransferEndpointSettingsMongoTarget): any;
export declare class DatatransferEndpointSettingsMongoTargetOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DatatransferEndpointSettingsMongoTarget | undefined;
    set internalValue(value: DatatransferEndpointSettingsMongoTarget | undefined);
    private _cleanupPolicy?;
    get cleanupPolicy(): string;
    set cleanupPolicy(value: string);
    resetCleanupPolicy(): void;
    get cleanupPolicyInput(): string | undefined;
    private _database?;
    get database(): string;
    set database(value: string);
    resetDatabase(): void;
    get databaseInput(): string | undefined;
    private _securityGroups?;
    get securityGroups(): string[];
    set securityGroups(value: string[]);
    resetSecurityGroups(): void;
    get securityGroupsInput(): string[] | undefined;
    private _subnetId?;
    get subnetId(): string;
    set subnetId(value: string);
    resetSubnetId(): void;
    get subnetIdInput(): string | undefined;
    private _connection;
    get connection(): DatatransferEndpointSettingsMongoTargetConnectionOutputReference;
    putConnection(value: DatatransferEndpointSettingsMongoTargetConnection): void;
    resetConnection(): void;
    get connectionInput(): DatatransferEndpointSettingsMongoTargetConnection | undefined;
}
export interface DatatransferEndpointSettingsMysqlSourceConnectionOnPremiseTlsModeDisabled {
}
export declare function datatransferEndpointSettingsMysqlSourceConnectionOnPremiseTlsModeDisabledToTerraform(struct?: DatatransferEndpointSettingsMysqlSourceConnectionOnPremiseTlsModeDisabledOutputReference | DatatransferEndpointSettingsMysqlSourceConnectionOnPremiseTlsModeDisabled): any;
export declare class DatatransferEndpointSettingsMysqlSourceConnectionOnPremiseTlsModeDisabledOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DatatransferEndpointSettingsMysqlSourceConnectionOnPremiseTlsModeDisabled | undefined;
    set internalValue(value: DatatransferEndpointSettingsMysqlSourceConnectionOnPremiseTlsModeDisabled | undefined);
}
export interface DatatransferEndpointSettingsMysqlSourceConnectionOnPremiseTlsModeEnabled {
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/datatransfer_endpoint#ca_certificate DatatransferEndpoint#ca_certificate}
    */
    readonly caCertificate?: string;
}
export declare function datatransferEndpointSettingsMysqlSourceConnectionOnPremiseTlsModeEnabledToTerraform(struct?: DatatransferEndpointSettingsMysqlSourceConnectionOnPremiseTlsModeEnabledOutputReference | DatatransferEndpointSettingsMysqlSourceConnectionOnPremiseTlsModeEnabled): any;
export declare class DatatransferEndpointSettingsMysqlSourceConnectionOnPremiseTlsModeEnabledOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DatatransferEndpointSettingsMysqlSourceConnectionOnPremiseTlsModeEnabled | undefined;
    set internalValue(value: DatatransferEndpointSettingsMysqlSourceConnectionOnPremiseTlsModeEnabled | undefined);
    private _caCertificate?;
    get caCertificate(): string;
    set caCertificate(value: string);
    resetCaCertificate(): void;
    get caCertificateInput(): string | undefined;
}
export interface DatatransferEndpointSettingsMysqlSourceConnectionOnPremiseTlsMode {
    /**
    * disabled block
    *
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/datatransfer_endpoint#disabled DatatransferEndpoint#disabled}
    */
    readonly disabled?: DatatransferEndpointSettingsMysqlSourceConnectionOnPremiseTlsModeDisabled;
    /**
    * enabled block
    *
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/datatransfer_endpoint#enabled DatatransferEndpoint#enabled}
    */
    readonly enabled?: DatatransferEndpointSettingsMysqlSourceConnectionOnPremiseTlsModeEnabled;
}
export declare function datatransferEndpointSettingsMysqlSourceConnectionOnPremiseTlsModeToTerraform(struct?: DatatransferEndpointSettingsMysqlSourceConnectionOnPremiseTlsModeOutputReference | DatatransferEndpointSettingsMysqlSourceConnectionOnPremiseTlsMode): any;
export declare class DatatransferEndpointSettingsMysqlSourceConnectionOnPremiseTlsModeOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DatatransferEndpointSettingsMysqlSourceConnectionOnPremiseTlsMode | undefined;
    set internalValue(value: DatatransferEndpointSettingsMysqlSourceConnectionOnPremiseTlsMode | undefined);
    private _disabled;
    get disabled(): DatatransferEndpointSettingsMysqlSourceConnectionOnPremiseTlsModeDisabledOutputReference;
    putDisabled(value: DatatransferEndpointSettingsMysqlSourceConnectionOnPremiseTlsModeDisabled): void;
    resetDisabled(): void;
    get disabledInput(): DatatransferEndpointSettingsMysqlSourceConnectionOnPremiseTlsModeDisabled | undefined;
    private _enabled;
    get enabled(): DatatransferEndpointSettingsMysqlSourceConnectionOnPremiseTlsModeEnabledOutputReference;
    putEnabled(value: DatatransferEndpointSettingsMysqlSourceConnectionOnPremiseTlsModeEnabled): void;
    resetEnabled(): void;
    get enabledInput(): DatatransferEndpointSettingsMysqlSourceConnectionOnPremiseTlsModeEnabled | undefined;
}
export interface DatatransferEndpointSettingsMysqlSourceConnectionOnPremise {
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/datatransfer_endpoint#hosts DatatransferEndpoint#hosts}
    */
    readonly hosts?: string[];
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/datatransfer_endpoint#port DatatransferEndpoint#port}
    */
    readonly port?: number;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/datatransfer_endpoint#subnet_id DatatransferEndpoint#subnet_id}
    */
    readonly subnetId?: string;
    /**
    * tls_mode block
    *
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/datatransfer_endpoint#tls_mode DatatransferEndpoint#tls_mode}
    */
    readonly tlsMode?: DatatransferEndpointSettingsMysqlSourceConnectionOnPremiseTlsMode;
}
export declare function datatransferEndpointSettingsMysqlSourceConnectionOnPremiseToTerraform(struct?: DatatransferEndpointSettingsMysqlSourceConnectionOnPremiseOutputReference | DatatransferEndpointSettingsMysqlSourceConnectionOnPremise): any;
export declare class DatatransferEndpointSettingsMysqlSourceConnectionOnPremiseOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DatatransferEndpointSettingsMysqlSourceConnectionOnPremise | undefined;
    set internalValue(value: DatatransferEndpointSettingsMysqlSourceConnectionOnPremise | undefined);
    private _hosts?;
    get hosts(): string[];
    set hosts(value: string[]);
    resetHosts(): void;
    get hostsInput(): string[] | undefined;
    private _port?;
    get port(): number;
    set port(value: number);
    resetPort(): void;
    get portInput(): number | undefined;
    private _subnetId?;
    get subnetId(): string;
    set subnetId(value: string);
    resetSubnetId(): void;
    get subnetIdInput(): string | undefined;
    private _tlsMode;
    get tlsMode(): DatatransferEndpointSettingsMysqlSourceConnectionOnPremiseTlsModeOutputReference;
    putTlsMode(value: DatatransferEndpointSettingsMysqlSourceConnectionOnPremiseTlsMode): void;
    resetTlsMode(): void;
    get tlsModeInput(): DatatransferEndpointSettingsMysqlSourceConnectionOnPremiseTlsMode | undefined;
}
export interface DatatransferEndpointSettingsMysqlSourceConnection {
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/datatransfer_endpoint#mdb_cluster_id DatatransferEndpoint#mdb_cluster_id}
    */
    readonly mdbClusterId?: string;
    /**
    * on_premise block
    *
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/datatransfer_endpoint#on_premise DatatransferEndpoint#on_premise}
    */
    readonly onPremise?: DatatransferEndpointSettingsMysqlSourceConnectionOnPremise;
}
export declare function datatransferEndpointSettingsMysqlSourceConnectionToTerraform(struct?: DatatransferEndpointSettingsMysqlSourceConnectionOutputReference | DatatransferEndpointSettingsMysqlSourceConnection): any;
export declare class DatatransferEndpointSettingsMysqlSourceConnectionOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DatatransferEndpointSettingsMysqlSourceConnection | undefined;
    set internalValue(value: DatatransferEndpointSettingsMysqlSourceConnection | undefined);
    private _mdbClusterId?;
    get mdbClusterId(): string;
    set mdbClusterId(value: string);
    resetMdbClusterId(): void;
    get mdbClusterIdInput(): string | undefined;
    private _onPremise;
    get onPremise(): DatatransferEndpointSettingsMysqlSourceConnectionOnPremiseOutputReference;
    putOnPremise(value: DatatransferEndpointSettingsMysqlSourceConnectionOnPremise): void;
    resetOnPremise(): void;
    get onPremiseInput(): DatatransferEndpointSettingsMysqlSourceConnectionOnPremise | undefined;
}
export interface DatatransferEndpointSettingsMysqlSourceObjectTransferSettings {
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/datatransfer_endpoint#routine DatatransferEndpoint#routine}
    */
    readonly routine?: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/datatransfer_endpoint#trigger DatatransferEndpoint#trigger}
    */
    readonly trigger?: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/datatransfer_endpoint#view DatatransferEndpoint#view}
    */
    readonly view?: string;
}
export declare function datatransferEndpointSettingsMysqlSourceObjectTransferSettingsToTerraform(struct?: DatatransferEndpointSettingsMysqlSourceObjectTransferSettingsOutputReference | DatatransferEndpointSettingsMysqlSourceObjectTransferSettings): any;
export declare class DatatransferEndpointSettingsMysqlSourceObjectTransferSettingsOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DatatransferEndpointSettingsMysqlSourceObjectTransferSettings | undefined;
    set internalValue(value: DatatransferEndpointSettingsMysqlSourceObjectTransferSettings | undefined);
    private _routine?;
    get routine(): string;
    set routine(value: string);
    resetRoutine(): void;
    get routineInput(): string | undefined;
    private _trigger?;
    get trigger(): string;
    set trigger(value: string);
    resetTrigger(): void;
    get triggerInput(): string | undefined;
    private _view?;
    get view(): string;
    set view(value: string);
    resetView(): void;
    get viewInput(): string | undefined;
}
export interface DatatransferEndpointSettingsMysqlSourcePassword {
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/datatransfer_endpoint#raw DatatransferEndpoint#raw}
    */
    readonly raw?: string;
}
export declare function datatransferEndpointSettingsMysqlSourcePasswordToTerraform(struct?: DatatransferEndpointSettingsMysqlSourcePasswordOutputReference | DatatransferEndpointSettingsMysqlSourcePassword): any;
export declare class DatatransferEndpointSettingsMysqlSourcePasswordOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DatatransferEndpointSettingsMysqlSourcePassword | undefined;
    set internalValue(value: DatatransferEndpointSettingsMysqlSourcePassword | undefined);
    private _raw?;
    get raw(): string;
    set raw(value: string);
    resetRaw(): void;
    get rawInput(): string | undefined;
}
export interface DatatransferEndpointSettingsMysqlSource {
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/datatransfer_endpoint#database DatatransferEndpoint#database}
    */
    readonly database?: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/datatransfer_endpoint#exclude_tables_regex DatatransferEndpoint#exclude_tables_regex}
    */
    readonly excludeTablesRegex?: string[];
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/datatransfer_endpoint#include_tables_regex DatatransferEndpoint#include_tables_regex}
    */
    readonly includeTablesRegex?: string[];
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/datatransfer_endpoint#security_groups DatatransferEndpoint#security_groups}
    */
    readonly securityGroups?: string[];
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/datatransfer_endpoint#service_database DatatransferEndpoint#service_database}
    */
    readonly serviceDatabase?: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/datatransfer_endpoint#timezone DatatransferEndpoint#timezone}
    */
    readonly timezone?: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/datatransfer_endpoint#user DatatransferEndpoint#user}
    */
    readonly user?: string;
    /**
    * connection block
    *
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/datatransfer_endpoint#connection DatatransferEndpoint#connection}
    */
    readonly connection?: DatatransferEndpointSettingsMysqlSourceConnection;
    /**
    * object_transfer_settings block
    *
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/datatransfer_endpoint#object_transfer_settings DatatransferEndpoint#object_transfer_settings}
    */
    readonly objectTransferSettings?: DatatransferEndpointSettingsMysqlSourceObjectTransferSettings;
    /**
    * password block
    *
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/datatransfer_endpoint#password DatatransferEndpoint#password}
    */
    readonly password?: DatatransferEndpointSettingsMysqlSourcePassword;
}
export declare function datatransferEndpointSettingsMysqlSourceToTerraform(struct?: DatatransferEndpointSettingsMysqlSourceOutputReference | DatatransferEndpointSettingsMysqlSource): any;
export declare class DatatransferEndpointSettingsMysqlSourceOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DatatransferEndpointSettingsMysqlSource | undefined;
    set internalValue(value: DatatransferEndpointSettingsMysqlSource | undefined);
    private _database?;
    get database(): string;
    set database(value: string);
    resetDatabase(): void;
    get databaseInput(): string | undefined;
    private _excludeTablesRegex?;
    get excludeTablesRegex(): string[];
    set excludeTablesRegex(value: string[]);
    resetExcludeTablesRegex(): void;
    get excludeTablesRegexInput(): string[] | undefined;
    private _includeTablesRegex?;
    get includeTablesRegex(): string[];
    set includeTablesRegex(value: string[]);
    resetIncludeTablesRegex(): void;
    get includeTablesRegexInput(): string[] | undefined;
    private _securityGroups?;
    get securityGroups(): string[];
    set securityGroups(value: string[]);
    resetSecurityGroups(): void;
    get securityGroupsInput(): string[] | undefined;
    private _serviceDatabase?;
    get serviceDatabase(): string;
    set serviceDatabase(value: string);
    resetServiceDatabase(): void;
    get serviceDatabaseInput(): string | undefined;
    private _timezone?;
    get timezone(): string;
    set timezone(value: string);
    resetTimezone(): void;
    get timezoneInput(): string | undefined;
    private _user?;
    get user(): string;
    set user(value: string);
    resetUser(): void;
    get userInput(): string | undefined;
    private _connection;
    get connection(): DatatransferEndpointSettingsMysqlSourceConnectionOutputReference;
    putConnection(value: DatatransferEndpointSettingsMysqlSourceConnection): void;
    resetConnection(): void;
    get connectionInput(): DatatransferEndpointSettingsMysqlSourceConnection | undefined;
    private _objectTransferSettings;
    get objectTransferSettings(): DatatransferEndpointSettingsMysqlSourceObjectTransferSettingsOutputReference;
    putObjectTransferSettings(value: DatatransferEndpointSettingsMysqlSourceObjectTransferSettings): void;
    resetObjectTransferSettings(): void;
    get objectTransferSettingsInput(): DatatransferEndpointSettingsMysqlSourceObjectTransferSettings | undefined;
    private _password;
    get password(): DatatransferEndpointSettingsMysqlSourcePasswordOutputReference;
    putPassword(value: DatatransferEndpointSettingsMysqlSourcePassword): void;
    resetPassword(): void;
    get passwordInput(): DatatransferEndpointSettingsMysqlSourcePassword | undefined;
}
export interface DatatransferEndpointSettingsMysqlTargetConnectionOnPremiseTlsModeDisabled {
}
export declare function datatransferEndpointSettingsMysqlTargetConnectionOnPremiseTlsModeDisabledToTerraform(struct?: DatatransferEndpointSettingsMysqlTargetConnectionOnPremiseTlsModeDisabledOutputReference | DatatransferEndpointSettingsMysqlTargetConnectionOnPremiseTlsModeDisabled): any;
export declare class DatatransferEndpointSettingsMysqlTargetConnectionOnPremiseTlsModeDisabledOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DatatransferEndpointSettingsMysqlTargetConnectionOnPremiseTlsModeDisabled | undefined;
    set internalValue(value: DatatransferEndpointSettingsMysqlTargetConnectionOnPremiseTlsModeDisabled | undefined);
}
export interface DatatransferEndpointSettingsMysqlTargetConnectionOnPremiseTlsModeEnabled {
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/datatransfer_endpoint#ca_certificate DatatransferEndpoint#ca_certificate}
    */
    readonly caCertificate?: string;
}
export declare function datatransferEndpointSettingsMysqlTargetConnectionOnPremiseTlsModeEnabledToTerraform(struct?: DatatransferEndpointSettingsMysqlTargetConnectionOnPremiseTlsModeEnabledOutputReference | DatatransferEndpointSettingsMysqlTargetConnectionOnPremiseTlsModeEnabled): any;
export declare class DatatransferEndpointSettingsMysqlTargetConnectionOnPremiseTlsModeEnabledOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DatatransferEndpointSettingsMysqlTargetConnectionOnPremiseTlsModeEnabled | undefined;
    set internalValue(value: DatatransferEndpointSettingsMysqlTargetConnectionOnPremiseTlsModeEnabled | undefined);
    private _caCertificate?;
    get caCertificate(): string;
    set caCertificate(value: string);
    resetCaCertificate(): void;
    get caCertificateInput(): string | undefined;
}
export interface DatatransferEndpointSettingsMysqlTargetConnectionOnPremiseTlsMode {
    /**
    * disabled block
    *
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/datatransfer_endpoint#disabled DatatransferEndpoint#disabled}
    */
    readonly disabled?: DatatransferEndpointSettingsMysqlTargetConnectionOnPremiseTlsModeDisabled;
    /**
    * enabled block
    *
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/datatransfer_endpoint#enabled DatatransferEndpoint#enabled}
    */
    readonly enabled?: DatatransferEndpointSettingsMysqlTargetConnectionOnPremiseTlsModeEnabled;
}
export declare function datatransferEndpointSettingsMysqlTargetConnectionOnPremiseTlsModeToTerraform(struct?: DatatransferEndpointSettingsMysqlTargetConnectionOnPremiseTlsModeOutputReference | DatatransferEndpointSettingsMysqlTargetConnectionOnPremiseTlsMode): any;
export declare class DatatransferEndpointSettingsMysqlTargetConnectionOnPremiseTlsModeOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DatatransferEndpointSettingsMysqlTargetConnectionOnPremiseTlsMode | undefined;
    set internalValue(value: DatatransferEndpointSettingsMysqlTargetConnectionOnPremiseTlsMode | undefined);
    private _disabled;
    get disabled(): DatatransferEndpointSettingsMysqlTargetConnectionOnPremiseTlsModeDisabledOutputReference;
    putDisabled(value: DatatransferEndpointSettingsMysqlTargetConnectionOnPremiseTlsModeDisabled): void;
    resetDisabled(): void;
    get disabledInput(): DatatransferEndpointSettingsMysqlTargetConnectionOnPremiseTlsModeDisabled | undefined;
    private _enabled;
    get enabled(): DatatransferEndpointSettingsMysqlTargetConnectionOnPremiseTlsModeEnabledOutputReference;
    putEnabled(value: DatatransferEndpointSettingsMysqlTargetConnectionOnPremiseTlsModeEnabled): void;
    resetEnabled(): void;
    get enabledInput(): DatatransferEndpointSettingsMysqlTargetConnectionOnPremiseTlsModeEnabled | undefined;
}
export interface DatatransferEndpointSettingsMysqlTargetConnectionOnPremise {
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/datatransfer_endpoint#hosts DatatransferEndpoint#hosts}
    */
    readonly hosts?: string[];
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/datatransfer_endpoint#port DatatransferEndpoint#port}
    */
    readonly port?: number;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/datatransfer_endpoint#subnet_id DatatransferEndpoint#subnet_id}
    */
    readonly subnetId?: string;
    /**
    * tls_mode block
    *
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/datatransfer_endpoint#tls_mode DatatransferEndpoint#tls_mode}
    */
    readonly tlsMode?: DatatransferEndpointSettingsMysqlTargetConnectionOnPremiseTlsMode;
}
export declare function datatransferEndpointSettingsMysqlTargetConnectionOnPremiseToTerraform(struct?: DatatransferEndpointSettingsMysqlTargetConnectionOnPremiseOutputReference | DatatransferEndpointSettingsMysqlTargetConnectionOnPremise): any;
export declare class DatatransferEndpointSettingsMysqlTargetConnectionOnPremiseOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DatatransferEndpointSettingsMysqlTargetConnectionOnPremise | undefined;
    set internalValue(value: DatatransferEndpointSettingsMysqlTargetConnectionOnPremise | undefined);
    private _hosts?;
    get hosts(): string[];
    set hosts(value: string[]);
    resetHosts(): void;
    get hostsInput(): string[] | undefined;
    private _port?;
    get port(): number;
    set port(value: number);
    resetPort(): void;
    get portInput(): number | undefined;
    private _subnetId?;
    get subnetId(): string;
    set subnetId(value: string);
    resetSubnetId(): void;
    get subnetIdInput(): string | undefined;
    private _tlsMode;
    get tlsMode(): DatatransferEndpointSettingsMysqlTargetConnectionOnPremiseTlsModeOutputReference;
    putTlsMode(value: DatatransferEndpointSettingsMysqlTargetConnectionOnPremiseTlsMode): void;
    resetTlsMode(): void;
    get tlsModeInput(): DatatransferEndpointSettingsMysqlTargetConnectionOnPremiseTlsMode | undefined;
}
export interface DatatransferEndpointSettingsMysqlTargetConnection {
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/datatransfer_endpoint#mdb_cluster_id DatatransferEndpoint#mdb_cluster_id}
    */
    readonly mdbClusterId?: string;
    /**
    * on_premise block
    *
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/datatransfer_endpoint#on_premise DatatransferEndpoint#on_premise}
    */
    readonly onPremise?: DatatransferEndpointSettingsMysqlTargetConnectionOnPremise;
}
export declare function datatransferEndpointSettingsMysqlTargetConnectionToTerraform(struct?: DatatransferEndpointSettingsMysqlTargetConnectionOutputReference | DatatransferEndpointSettingsMysqlTargetConnection): any;
export declare class DatatransferEndpointSettingsMysqlTargetConnectionOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DatatransferEndpointSettingsMysqlTargetConnection | undefined;
    set internalValue(value: DatatransferEndpointSettingsMysqlTargetConnection | undefined);
    private _mdbClusterId?;
    get mdbClusterId(): string;
    set mdbClusterId(value: string);
    resetMdbClusterId(): void;
    get mdbClusterIdInput(): string | undefined;
    private _onPremise;
    get onPremise(): DatatransferEndpointSettingsMysqlTargetConnectionOnPremiseOutputReference;
    putOnPremise(value: DatatransferEndpointSettingsMysqlTargetConnectionOnPremise): void;
    resetOnPremise(): void;
    get onPremiseInput(): DatatransferEndpointSettingsMysqlTargetConnectionOnPremise | undefined;
}
export interface DatatransferEndpointSettingsMysqlTargetPassword {
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/datatransfer_endpoint#raw DatatransferEndpoint#raw}
    */
    readonly raw?: string;
}
export declare function datatransferEndpointSettingsMysqlTargetPasswordToTerraform(struct?: DatatransferEndpointSettingsMysqlTargetPasswordOutputReference | DatatransferEndpointSettingsMysqlTargetPassword): any;
export declare class DatatransferEndpointSettingsMysqlTargetPasswordOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DatatransferEndpointSettingsMysqlTargetPassword | undefined;
    set internalValue(value: DatatransferEndpointSettingsMysqlTargetPassword | undefined);
    private _raw?;
    get raw(): string;
    set raw(value: string);
    resetRaw(): void;
    get rawInput(): string | undefined;
}
export interface DatatransferEndpointSettingsMysqlTarget {
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/datatransfer_endpoint#database DatatransferEndpoint#database}
    */
    readonly database?: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/datatransfer_endpoint#security_groups DatatransferEndpoint#security_groups}
    */
    readonly securityGroups?: string[];
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/datatransfer_endpoint#skip_constraint_checks DatatransferEndpoint#skip_constraint_checks}
    */
    readonly skipConstraintChecks?: boolean | cdktf.IResolvable;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/datatransfer_endpoint#sql_mode DatatransferEndpoint#sql_mode}
    */
    readonly sqlMode?: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/datatransfer_endpoint#timezone DatatransferEndpoint#timezone}
    */
    readonly timezone?: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/datatransfer_endpoint#user DatatransferEndpoint#user}
    */
    readonly user?: string;
    /**
    * connection block
    *
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/datatransfer_endpoint#connection DatatransferEndpoint#connection}
    */
    readonly connection?: DatatransferEndpointSettingsMysqlTargetConnection;
    /**
    * password block
    *
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/datatransfer_endpoint#password DatatransferEndpoint#password}
    */
    readonly password?: DatatransferEndpointSettingsMysqlTargetPassword;
}
export declare function datatransferEndpointSettingsMysqlTargetToTerraform(struct?: DatatransferEndpointSettingsMysqlTargetOutputReference | DatatransferEndpointSettingsMysqlTarget): any;
export declare class DatatransferEndpointSettingsMysqlTargetOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DatatransferEndpointSettingsMysqlTarget | undefined;
    set internalValue(value: DatatransferEndpointSettingsMysqlTarget | undefined);
    private _database?;
    get database(): string;
    set database(value: string);
    resetDatabase(): void;
    get databaseInput(): string | undefined;
    private _securityGroups?;
    get securityGroups(): string[];
    set securityGroups(value: string[]);
    resetSecurityGroups(): void;
    get securityGroupsInput(): string[] | undefined;
    private _skipConstraintChecks?;
    get skipConstraintChecks(): boolean | cdktf.IResolvable;
    set skipConstraintChecks(value: boolean | cdktf.IResolvable);
    resetSkipConstraintChecks(): void;
    get skipConstraintChecksInput(): boolean | cdktf.IResolvable | undefined;
    private _sqlMode?;
    get sqlMode(): string;
    set sqlMode(value: string);
    resetSqlMode(): void;
    get sqlModeInput(): string | undefined;
    private _timezone?;
    get timezone(): string;
    set timezone(value: string);
    resetTimezone(): void;
    get timezoneInput(): string | undefined;
    private _user?;
    get user(): string;
    set user(value: string);
    resetUser(): void;
    get userInput(): string | undefined;
    private _connection;
    get connection(): DatatransferEndpointSettingsMysqlTargetConnectionOutputReference;
    putConnection(value: DatatransferEndpointSettingsMysqlTargetConnection): void;
    resetConnection(): void;
    get connectionInput(): DatatransferEndpointSettingsMysqlTargetConnection | undefined;
    private _password;
    get password(): DatatransferEndpointSettingsMysqlTargetPasswordOutputReference;
    putPassword(value: DatatransferEndpointSettingsMysqlTargetPassword): void;
    resetPassword(): void;
    get passwordInput(): DatatransferEndpointSettingsMysqlTargetPassword | undefined;
}
export interface DatatransferEndpointSettingsPostgresSourceConnectionOnPremiseTlsModeDisabled {
}
export declare function datatransferEndpointSettingsPostgresSourceConnectionOnPremiseTlsModeDisabledToTerraform(struct?: DatatransferEndpointSettingsPostgresSourceConnectionOnPremiseTlsModeDisabledOutputReference | DatatransferEndpointSettingsPostgresSourceConnectionOnPremiseTlsModeDisabled): any;
export declare class DatatransferEndpointSettingsPostgresSourceConnectionOnPremiseTlsModeDisabledOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DatatransferEndpointSettingsPostgresSourceConnectionOnPremiseTlsModeDisabled | undefined;
    set internalValue(value: DatatransferEndpointSettingsPostgresSourceConnectionOnPremiseTlsModeDisabled | undefined);
}
export interface DatatransferEndpointSettingsPostgresSourceConnectionOnPremiseTlsModeEnabled {
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/datatransfer_endpoint#ca_certificate DatatransferEndpoint#ca_certificate}
    */
    readonly caCertificate?: string;
}
export declare function datatransferEndpointSettingsPostgresSourceConnectionOnPremiseTlsModeEnabledToTerraform(struct?: DatatransferEndpointSettingsPostgresSourceConnectionOnPremiseTlsModeEnabledOutputReference | DatatransferEndpointSettingsPostgresSourceConnectionOnPremiseTlsModeEnabled): any;
export declare class DatatransferEndpointSettingsPostgresSourceConnectionOnPremiseTlsModeEnabledOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DatatransferEndpointSettingsPostgresSourceConnectionOnPremiseTlsModeEnabled | undefined;
    set internalValue(value: DatatransferEndpointSettingsPostgresSourceConnectionOnPremiseTlsModeEnabled | undefined);
    private _caCertificate?;
    get caCertificate(): string;
    set caCertificate(value: string);
    resetCaCertificate(): void;
    get caCertificateInput(): string | undefined;
}
export interface DatatransferEndpointSettingsPostgresSourceConnectionOnPremiseTlsMode {
    /**
    * disabled block
    *
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/datatransfer_endpoint#disabled DatatransferEndpoint#disabled}
    */
    readonly disabled?: DatatransferEndpointSettingsPostgresSourceConnectionOnPremiseTlsModeDisabled;
    /**
    * enabled block
    *
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/datatransfer_endpoint#enabled DatatransferEndpoint#enabled}
    */
    readonly enabled?: DatatransferEndpointSettingsPostgresSourceConnectionOnPremiseTlsModeEnabled;
}
export declare function datatransferEndpointSettingsPostgresSourceConnectionOnPremiseTlsModeToTerraform(struct?: DatatransferEndpointSettingsPostgresSourceConnectionOnPremiseTlsModeOutputReference | DatatransferEndpointSettingsPostgresSourceConnectionOnPremiseTlsMode): any;
export declare class DatatransferEndpointSettingsPostgresSourceConnectionOnPremiseTlsModeOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DatatransferEndpointSettingsPostgresSourceConnectionOnPremiseTlsMode | undefined;
    set internalValue(value: DatatransferEndpointSettingsPostgresSourceConnectionOnPremiseTlsMode | undefined);
    private _disabled;
    get disabled(): DatatransferEndpointSettingsPostgresSourceConnectionOnPremiseTlsModeDisabledOutputReference;
    putDisabled(value: DatatransferEndpointSettingsPostgresSourceConnectionOnPremiseTlsModeDisabled): void;
    resetDisabled(): void;
    get disabledInput(): DatatransferEndpointSettingsPostgresSourceConnectionOnPremiseTlsModeDisabled | undefined;
    private _enabled;
    get enabled(): DatatransferEndpointSettingsPostgresSourceConnectionOnPremiseTlsModeEnabledOutputReference;
    putEnabled(value: DatatransferEndpointSettingsPostgresSourceConnectionOnPremiseTlsModeEnabled): void;
    resetEnabled(): void;
    get enabledInput(): DatatransferEndpointSettingsPostgresSourceConnectionOnPremiseTlsModeEnabled | undefined;
}
export interface DatatransferEndpointSettingsPostgresSourceConnectionOnPremise {
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/datatransfer_endpoint#hosts DatatransferEndpoint#hosts}
    */
    readonly hosts?: string[];
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/datatransfer_endpoint#port DatatransferEndpoint#port}
    */
    readonly port?: number;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/datatransfer_endpoint#subnet_id DatatransferEndpoint#subnet_id}
    */
    readonly subnetId?: string;
    /**
    * tls_mode block
    *
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/datatransfer_endpoint#tls_mode DatatransferEndpoint#tls_mode}
    */
    readonly tlsMode?: DatatransferEndpointSettingsPostgresSourceConnectionOnPremiseTlsMode;
}
export declare function datatransferEndpointSettingsPostgresSourceConnectionOnPremiseToTerraform(struct?: DatatransferEndpointSettingsPostgresSourceConnectionOnPremiseOutputReference | DatatransferEndpointSettingsPostgresSourceConnectionOnPremise): any;
export declare class DatatransferEndpointSettingsPostgresSourceConnectionOnPremiseOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DatatransferEndpointSettingsPostgresSourceConnectionOnPremise | undefined;
    set internalValue(value: DatatransferEndpointSettingsPostgresSourceConnectionOnPremise | undefined);
    private _hosts?;
    get hosts(): string[];
    set hosts(value: string[]);
    resetHosts(): void;
    get hostsInput(): string[] | undefined;
    private _port?;
    get port(): number;
    set port(value: number);
    resetPort(): void;
    get portInput(): number | undefined;
    private _subnetId?;
    get subnetId(): string;
    set subnetId(value: string);
    resetSubnetId(): void;
    get subnetIdInput(): string | undefined;
    private _tlsMode;
    get tlsMode(): DatatransferEndpointSettingsPostgresSourceConnectionOnPremiseTlsModeOutputReference;
    putTlsMode(value: DatatransferEndpointSettingsPostgresSourceConnectionOnPremiseTlsMode): void;
    resetTlsMode(): void;
    get tlsModeInput(): DatatransferEndpointSettingsPostgresSourceConnectionOnPremiseTlsMode | undefined;
}
export interface DatatransferEndpointSettingsPostgresSourceConnection {
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/datatransfer_endpoint#mdb_cluster_id DatatransferEndpoint#mdb_cluster_id}
    */
    readonly mdbClusterId?: string;
    /**
    * on_premise block
    *
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/datatransfer_endpoint#on_premise DatatransferEndpoint#on_premise}
    */
    readonly onPremise?: DatatransferEndpointSettingsPostgresSourceConnectionOnPremise;
}
export declare function datatransferEndpointSettingsPostgresSourceConnectionToTerraform(struct?: DatatransferEndpointSettingsPostgresSourceConnectionOutputReference | DatatransferEndpointSettingsPostgresSourceConnection): any;
export declare class DatatransferEndpointSettingsPostgresSourceConnectionOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DatatransferEndpointSettingsPostgresSourceConnection | undefined;
    set internalValue(value: DatatransferEndpointSettingsPostgresSourceConnection | undefined);
    private _mdbClusterId?;
    get mdbClusterId(): string;
    set mdbClusterId(value: string);
    resetMdbClusterId(): void;
    get mdbClusterIdInput(): string | undefined;
    private _onPremise;
    get onPremise(): DatatransferEndpointSettingsPostgresSourceConnectionOnPremiseOutputReference;
    putOnPremise(value: DatatransferEndpointSettingsPostgresSourceConnectionOnPremise): void;
    resetOnPremise(): void;
    get onPremiseInput(): DatatransferEndpointSettingsPostgresSourceConnectionOnPremise | undefined;
}
export interface DatatransferEndpointSettingsPostgresSourceObjectTransferSettings {
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/datatransfer_endpoint#cast DatatransferEndpoint#cast}
    */
    readonly cast?: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/datatransfer_endpoint#collation DatatransferEndpoint#collation}
    */
    readonly collation?: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/datatransfer_endpoint#constraint DatatransferEndpoint#constraint}
    */
    readonly constraint?: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/datatransfer_endpoint#default_values DatatransferEndpoint#default_values}
    */
    readonly defaultValues?: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/datatransfer_endpoint#fk_constraint DatatransferEndpoint#fk_constraint}
    */
    readonly fkConstraint?: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/datatransfer_endpoint#function DatatransferEndpoint#function}
    */
    readonly function?: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/datatransfer_endpoint#index DatatransferEndpoint#index}
    */
    readonly index?: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/datatransfer_endpoint#materialized_view DatatransferEndpoint#materialized_view}
    */
    readonly materializedView?: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/datatransfer_endpoint#policy DatatransferEndpoint#policy}
    */
    readonly policy?: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/datatransfer_endpoint#primary_key DatatransferEndpoint#primary_key}
    */
    readonly primaryKey?: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/datatransfer_endpoint#rule DatatransferEndpoint#rule}
    */
    readonly rule?: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/datatransfer_endpoint#sequence DatatransferEndpoint#sequence}
    */
    readonly sequence?: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/datatransfer_endpoint#sequence_owned_by DatatransferEndpoint#sequence_owned_by}
    */
    readonly sequenceOwnedBy?: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/datatransfer_endpoint#table DatatransferEndpoint#table}
    */
    readonly table?: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/datatransfer_endpoint#trigger DatatransferEndpoint#trigger}
    */
    readonly trigger?: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/datatransfer_endpoint#type DatatransferEndpoint#type}
    */
    readonly type?: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/datatransfer_endpoint#view DatatransferEndpoint#view}
    */
    readonly view?: string;
}
export declare function datatransferEndpointSettingsPostgresSourceObjectTransferSettingsToTerraform(struct?: DatatransferEndpointSettingsPostgresSourceObjectTransferSettingsOutputReference | DatatransferEndpointSettingsPostgresSourceObjectTransferSettings): any;
export declare class DatatransferEndpointSettingsPostgresSourceObjectTransferSettingsOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DatatransferEndpointSettingsPostgresSourceObjectTransferSettings | undefined;
    set internalValue(value: DatatransferEndpointSettingsPostgresSourceObjectTransferSettings | undefined);
    private _cast?;
    get cast(): string;
    set cast(value: string);
    resetCast(): void;
    get castInput(): string | undefined;
    private _collation?;
    get collation(): string;
    set collation(value: string);
    resetCollation(): void;
    get collationInput(): string | undefined;
    private _constraint?;
    get constraint(): string;
    set constraint(value: string);
    resetConstraint(): void;
    get constraintInput(): string | undefined;
    private _defaultValues?;
    get defaultValues(): string;
    set defaultValues(value: string);
    resetDefaultValues(): void;
    get defaultValuesInput(): string | undefined;
    private _fkConstraint?;
    get fkConstraint(): string;
    set fkConstraint(value: string);
    resetFkConstraint(): void;
    get fkConstraintInput(): string | undefined;
    private _function?;
    get function(): string;
    set function(value: string);
    resetFunction(): void;
    get functionInput(): string | undefined;
    private _index?;
    get index(): string;
    set index(value: string);
    resetIndex(): void;
    get indexInput(): string | undefined;
    private _materializedView?;
    get materializedView(): string;
    set materializedView(value: string);
    resetMaterializedView(): void;
    get materializedViewInput(): string | undefined;
    private _policy?;
    get policy(): string;
    set policy(value: string);
    resetPolicy(): void;
    get policyInput(): string | undefined;
    private _primaryKey?;
    get primaryKey(): string;
    set primaryKey(value: string);
    resetPrimaryKey(): void;
    get primaryKeyInput(): string | undefined;
    private _rule?;
    get rule(): string;
    set rule(value: string);
    resetRule(): void;
    get ruleInput(): string | undefined;
    private _sequence?;
    get sequence(): string;
    set sequence(value: string);
    resetSequence(): void;
    get sequenceInput(): string | undefined;
    private _sequenceOwnedBy?;
    get sequenceOwnedBy(): string;
    set sequenceOwnedBy(value: string);
    resetSequenceOwnedBy(): void;
    get sequenceOwnedByInput(): string | undefined;
    private _table?;
    get table(): string;
    set table(value: string);
    resetTable(): void;
    get tableInput(): string | undefined;
    private _trigger?;
    get trigger(): string;
    set trigger(value: string);
    resetTrigger(): void;
    get triggerInput(): string | undefined;
    private _type?;
    get type(): string;
    set type(value: string);
    resetType(): void;
    get typeInput(): string | undefined;
    private _view?;
    get view(): string;
    set view(value: string);
    resetView(): void;
    get viewInput(): string | undefined;
}
export interface DatatransferEndpointSettingsPostgresSourcePassword {
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/datatransfer_endpoint#raw DatatransferEndpoint#raw}
    */
    readonly raw?: string;
}
export declare function datatransferEndpointSettingsPostgresSourcePasswordToTerraform(struct?: DatatransferEndpointSettingsPostgresSourcePasswordOutputReference | DatatransferEndpointSettingsPostgresSourcePassword): any;
export declare class DatatransferEndpointSettingsPostgresSourcePasswordOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DatatransferEndpointSettingsPostgresSourcePassword | undefined;
    set internalValue(value: DatatransferEndpointSettingsPostgresSourcePassword | undefined);
    private _raw?;
    get raw(): string;
    set raw(value: string);
    resetRaw(): void;
    get rawInput(): string | undefined;
}
export interface DatatransferEndpointSettingsPostgresSource {
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/datatransfer_endpoint#database DatatransferEndpoint#database}
    */
    readonly database?: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/datatransfer_endpoint#exclude_tables DatatransferEndpoint#exclude_tables}
    */
    readonly excludeTables?: string[];
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/datatransfer_endpoint#include_tables DatatransferEndpoint#include_tables}
    */
    readonly includeTables?: string[];
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/datatransfer_endpoint#security_groups DatatransferEndpoint#security_groups}
    */
    readonly securityGroups?: string[];
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/datatransfer_endpoint#service_schema DatatransferEndpoint#service_schema}
    */
    readonly serviceSchema?: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/datatransfer_endpoint#slot_gigabyte_lag_limit DatatransferEndpoint#slot_gigabyte_lag_limit}
    */
    readonly slotGigabyteLagLimit?: number;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/datatransfer_endpoint#user DatatransferEndpoint#user}
    */
    readonly user?: string;
    /**
    * connection block
    *
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/datatransfer_endpoint#connection DatatransferEndpoint#connection}
    */
    readonly connection?: DatatransferEndpointSettingsPostgresSourceConnection;
    /**
    * object_transfer_settings block
    *
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/datatransfer_endpoint#object_transfer_settings DatatransferEndpoint#object_transfer_settings}
    */
    readonly objectTransferSettings?: DatatransferEndpointSettingsPostgresSourceObjectTransferSettings;
    /**
    * password block
    *
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/datatransfer_endpoint#password DatatransferEndpoint#password}
    */
    readonly password?: DatatransferEndpointSettingsPostgresSourcePassword;
}
export declare function datatransferEndpointSettingsPostgresSourceToTerraform(struct?: DatatransferEndpointSettingsPostgresSourceOutputReference | DatatransferEndpointSettingsPostgresSource): any;
export declare class DatatransferEndpointSettingsPostgresSourceOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DatatransferEndpointSettingsPostgresSource | undefined;
    set internalValue(value: DatatransferEndpointSettingsPostgresSource | undefined);
    private _database?;
    get database(): string;
    set database(value: string);
    resetDatabase(): void;
    get databaseInput(): string | undefined;
    private _excludeTables?;
    get excludeTables(): string[];
    set excludeTables(value: string[]);
    resetExcludeTables(): void;
    get excludeTablesInput(): string[] | undefined;
    private _includeTables?;
    get includeTables(): string[];
    set includeTables(value: string[]);
    resetIncludeTables(): void;
    get includeTablesInput(): string[] | undefined;
    private _securityGroups?;
    get securityGroups(): string[];
    set securityGroups(value: string[]);
    resetSecurityGroups(): void;
    get securityGroupsInput(): string[] | undefined;
    private _serviceSchema?;
    get serviceSchema(): string;
    set serviceSchema(value: string);
    resetServiceSchema(): void;
    get serviceSchemaInput(): string | undefined;
    private _slotGigabyteLagLimit?;
    get slotGigabyteLagLimit(): number;
    set slotGigabyteLagLimit(value: number);
    resetSlotGigabyteLagLimit(): void;
    get slotGigabyteLagLimitInput(): number | undefined;
    private _user?;
    get user(): string;
    set user(value: string);
    resetUser(): void;
    get userInput(): string | undefined;
    private _connection;
    get connection(): DatatransferEndpointSettingsPostgresSourceConnectionOutputReference;
    putConnection(value: DatatransferEndpointSettingsPostgresSourceConnection): void;
    resetConnection(): void;
    get connectionInput(): DatatransferEndpointSettingsPostgresSourceConnection | undefined;
    private _objectTransferSettings;
    get objectTransferSettings(): DatatransferEndpointSettingsPostgresSourceObjectTransferSettingsOutputReference;
    putObjectTransferSettings(value: DatatransferEndpointSettingsPostgresSourceObjectTransferSettings): void;
    resetObjectTransferSettings(): void;
    get objectTransferSettingsInput(): DatatransferEndpointSettingsPostgresSourceObjectTransferSettings | undefined;
    private _password;
    get password(): DatatransferEndpointSettingsPostgresSourcePasswordOutputReference;
    putPassword(value: DatatransferEndpointSettingsPostgresSourcePassword): void;
    resetPassword(): void;
    get passwordInput(): DatatransferEndpointSettingsPostgresSourcePassword | undefined;
}
export interface DatatransferEndpointSettingsPostgresTargetConnectionOnPremiseTlsModeDisabled {
}
export declare function datatransferEndpointSettingsPostgresTargetConnectionOnPremiseTlsModeDisabledToTerraform(struct?: DatatransferEndpointSettingsPostgresTargetConnectionOnPremiseTlsModeDisabledOutputReference | DatatransferEndpointSettingsPostgresTargetConnectionOnPremiseTlsModeDisabled): any;
export declare class DatatransferEndpointSettingsPostgresTargetConnectionOnPremiseTlsModeDisabledOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DatatransferEndpointSettingsPostgresTargetConnectionOnPremiseTlsModeDisabled | undefined;
    set internalValue(value: DatatransferEndpointSettingsPostgresTargetConnectionOnPremiseTlsModeDisabled | undefined);
}
export interface DatatransferEndpointSettingsPostgresTargetConnectionOnPremiseTlsModeEnabled {
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/datatransfer_endpoint#ca_certificate DatatransferEndpoint#ca_certificate}
    */
    readonly caCertificate?: string;
}
export declare function datatransferEndpointSettingsPostgresTargetConnectionOnPremiseTlsModeEnabledToTerraform(struct?: DatatransferEndpointSettingsPostgresTargetConnectionOnPremiseTlsModeEnabledOutputReference | DatatransferEndpointSettingsPostgresTargetConnectionOnPremiseTlsModeEnabled): any;
export declare class DatatransferEndpointSettingsPostgresTargetConnectionOnPremiseTlsModeEnabledOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DatatransferEndpointSettingsPostgresTargetConnectionOnPremiseTlsModeEnabled | undefined;
    set internalValue(value: DatatransferEndpointSettingsPostgresTargetConnectionOnPremiseTlsModeEnabled | undefined);
    private _caCertificate?;
    get caCertificate(): string;
    set caCertificate(value: string);
    resetCaCertificate(): void;
    get caCertificateInput(): string | undefined;
}
export interface DatatransferEndpointSettingsPostgresTargetConnectionOnPremiseTlsMode {
    /**
    * disabled block
    *
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/datatransfer_endpoint#disabled DatatransferEndpoint#disabled}
    */
    readonly disabled?: DatatransferEndpointSettingsPostgresTargetConnectionOnPremiseTlsModeDisabled;
    /**
    * enabled block
    *
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/datatransfer_endpoint#enabled DatatransferEndpoint#enabled}
    */
    readonly enabled?: DatatransferEndpointSettingsPostgresTargetConnectionOnPremiseTlsModeEnabled;
}
export declare function datatransferEndpointSettingsPostgresTargetConnectionOnPremiseTlsModeToTerraform(struct?: DatatransferEndpointSettingsPostgresTargetConnectionOnPremiseTlsModeOutputReference | DatatransferEndpointSettingsPostgresTargetConnectionOnPremiseTlsMode): any;
export declare class DatatransferEndpointSettingsPostgresTargetConnectionOnPremiseTlsModeOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DatatransferEndpointSettingsPostgresTargetConnectionOnPremiseTlsMode | undefined;
    set internalValue(value: DatatransferEndpointSettingsPostgresTargetConnectionOnPremiseTlsMode | undefined);
    private _disabled;
    get disabled(): DatatransferEndpointSettingsPostgresTargetConnectionOnPremiseTlsModeDisabledOutputReference;
    putDisabled(value: DatatransferEndpointSettingsPostgresTargetConnectionOnPremiseTlsModeDisabled): void;
    resetDisabled(): void;
    get disabledInput(): DatatransferEndpointSettingsPostgresTargetConnectionOnPremiseTlsModeDisabled | undefined;
    private _enabled;
    get enabled(): DatatransferEndpointSettingsPostgresTargetConnectionOnPremiseTlsModeEnabledOutputReference;
    putEnabled(value: DatatransferEndpointSettingsPostgresTargetConnectionOnPremiseTlsModeEnabled): void;
    resetEnabled(): void;
    get enabledInput(): DatatransferEndpointSettingsPostgresTargetConnectionOnPremiseTlsModeEnabled | undefined;
}
export interface DatatransferEndpointSettingsPostgresTargetConnectionOnPremise {
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/datatransfer_endpoint#hosts DatatransferEndpoint#hosts}
    */
    readonly hosts?: string[];
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/datatransfer_endpoint#port DatatransferEndpoint#port}
    */
    readonly port?: number;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/datatransfer_endpoint#subnet_id DatatransferEndpoint#subnet_id}
    */
    readonly subnetId?: string;
    /**
    * tls_mode block
    *
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/datatransfer_endpoint#tls_mode DatatransferEndpoint#tls_mode}
    */
    readonly tlsMode?: DatatransferEndpointSettingsPostgresTargetConnectionOnPremiseTlsMode;
}
export declare function datatransferEndpointSettingsPostgresTargetConnectionOnPremiseToTerraform(struct?: DatatransferEndpointSettingsPostgresTargetConnectionOnPremiseOutputReference | DatatransferEndpointSettingsPostgresTargetConnectionOnPremise): any;
export declare class DatatransferEndpointSettingsPostgresTargetConnectionOnPremiseOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DatatransferEndpointSettingsPostgresTargetConnectionOnPremise | undefined;
    set internalValue(value: DatatransferEndpointSettingsPostgresTargetConnectionOnPremise | undefined);
    private _hosts?;
    get hosts(): string[];
    set hosts(value: string[]);
    resetHosts(): void;
    get hostsInput(): string[] | undefined;
    private _port?;
    get port(): number;
    set port(value: number);
    resetPort(): void;
    get portInput(): number | undefined;
    private _subnetId?;
    get subnetId(): string;
    set subnetId(value: string);
    resetSubnetId(): void;
    get subnetIdInput(): string | undefined;
    private _tlsMode;
    get tlsMode(): DatatransferEndpointSettingsPostgresTargetConnectionOnPremiseTlsModeOutputReference;
    putTlsMode(value: DatatransferEndpointSettingsPostgresTargetConnectionOnPremiseTlsMode): void;
    resetTlsMode(): void;
    get tlsModeInput(): DatatransferEndpointSettingsPostgresTargetConnectionOnPremiseTlsMode | undefined;
}
export interface DatatransferEndpointSettingsPostgresTargetConnection {
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/datatransfer_endpoint#mdb_cluster_id DatatransferEndpoint#mdb_cluster_id}
    */
    readonly mdbClusterId?: string;
    /**
    * on_premise block
    *
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/datatransfer_endpoint#on_premise DatatransferEndpoint#on_premise}
    */
    readonly onPremise?: DatatransferEndpointSettingsPostgresTargetConnectionOnPremise;
}
export declare function datatransferEndpointSettingsPostgresTargetConnectionToTerraform(struct?: DatatransferEndpointSettingsPostgresTargetConnectionOutputReference | DatatransferEndpointSettingsPostgresTargetConnection): any;
export declare class DatatransferEndpointSettingsPostgresTargetConnectionOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DatatransferEndpointSettingsPostgresTargetConnection | undefined;
    set internalValue(value: DatatransferEndpointSettingsPostgresTargetConnection | undefined);
    private _mdbClusterId?;
    get mdbClusterId(): string;
    set mdbClusterId(value: string);
    resetMdbClusterId(): void;
    get mdbClusterIdInput(): string | undefined;
    private _onPremise;
    get onPremise(): DatatransferEndpointSettingsPostgresTargetConnectionOnPremiseOutputReference;
    putOnPremise(value: DatatransferEndpointSettingsPostgresTargetConnectionOnPremise): void;
    resetOnPremise(): void;
    get onPremiseInput(): DatatransferEndpointSettingsPostgresTargetConnectionOnPremise | undefined;
}
export interface DatatransferEndpointSettingsPostgresTargetPassword {
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/datatransfer_endpoint#raw DatatransferEndpoint#raw}
    */
    readonly raw?: string;
}
export declare function datatransferEndpointSettingsPostgresTargetPasswordToTerraform(struct?: DatatransferEndpointSettingsPostgresTargetPasswordOutputReference | DatatransferEndpointSettingsPostgresTargetPassword): any;
export declare class DatatransferEndpointSettingsPostgresTargetPasswordOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DatatransferEndpointSettingsPostgresTargetPassword | undefined;
    set internalValue(value: DatatransferEndpointSettingsPostgresTargetPassword | undefined);
    private _raw?;
    get raw(): string;
    set raw(value: string);
    resetRaw(): void;
    get rawInput(): string | undefined;
}
export interface DatatransferEndpointSettingsPostgresTarget {
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/datatransfer_endpoint#database DatatransferEndpoint#database}
    */
    readonly database?: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/datatransfer_endpoint#security_groups DatatransferEndpoint#security_groups}
    */
    readonly securityGroups?: string[];
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/datatransfer_endpoint#user DatatransferEndpoint#user}
    */
    readonly user?: string;
    /**
    * connection block
    *
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/datatransfer_endpoint#connection DatatransferEndpoint#connection}
    */
    readonly connection?: DatatransferEndpointSettingsPostgresTargetConnection;
    /**
    * password block
    *
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/datatransfer_endpoint#password DatatransferEndpoint#password}
    */
    readonly password?: DatatransferEndpointSettingsPostgresTargetPassword;
}
export declare function datatransferEndpointSettingsPostgresTargetToTerraform(struct?: DatatransferEndpointSettingsPostgresTargetOutputReference | DatatransferEndpointSettingsPostgresTarget): any;
export declare class DatatransferEndpointSettingsPostgresTargetOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DatatransferEndpointSettingsPostgresTarget | undefined;
    set internalValue(value: DatatransferEndpointSettingsPostgresTarget | undefined);
    private _database?;
    get database(): string;
    set database(value: string);
    resetDatabase(): void;
    get databaseInput(): string | undefined;
    private _securityGroups?;
    get securityGroups(): string[];
    set securityGroups(value: string[]);
    resetSecurityGroups(): void;
    get securityGroupsInput(): string[] | undefined;
    private _user?;
    get user(): string;
    set user(value: string);
    resetUser(): void;
    get userInput(): string | undefined;
    private _connection;
    get connection(): DatatransferEndpointSettingsPostgresTargetConnectionOutputReference;
    putConnection(value: DatatransferEndpointSettingsPostgresTargetConnection): void;
    resetConnection(): void;
    get connectionInput(): DatatransferEndpointSettingsPostgresTargetConnection | undefined;
    private _password;
    get password(): DatatransferEndpointSettingsPostgresTargetPasswordOutputReference;
    putPassword(value: DatatransferEndpointSettingsPostgresTargetPassword): void;
    resetPassword(): void;
    get passwordInput(): DatatransferEndpointSettingsPostgresTargetPassword | undefined;
}
export interface DatatransferEndpointSettings {
    /**
    * clickhouse_source block
    *
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/datatransfer_endpoint#clickhouse_source DatatransferEndpoint#clickhouse_source}
    */
    readonly clickhouseSource?: DatatransferEndpointSettingsClickhouseSource;
    /**
    * clickhouse_target block
    *
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/datatransfer_endpoint#clickhouse_target DatatransferEndpoint#clickhouse_target}
    */
    readonly clickhouseTarget?: DatatransferEndpointSettingsClickhouseTarget;
    /**
    * mongo_source block
    *
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/datatransfer_endpoint#mongo_source DatatransferEndpoint#mongo_source}
    */
    readonly mongoSource?: DatatransferEndpointSettingsMongoSource;
    /**
    * mongo_target block
    *
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/datatransfer_endpoint#mongo_target DatatransferEndpoint#mongo_target}
    */
    readonly mongoTarget?: DatatransferEndpointSettingsMongoTarget;
    /**
    * mysql_source block
    *
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/datatransfer_endpoint#mysql_source DatatransferEndpoint#mysql_source}
    */
    readonly mysqlSource?: DatatransferEndpointSettingsMysqlSource;
    /**
    * mysql_target block
    *
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/datatransfer_endpoint#mysql_target DatatransferEndpoint#mysql_target}
    */
    readonly mysqlTarget?: DatatransferEndpointSettingsMysqlTarget;
    /**
    * postgres_source block
    *
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/datatransfer_endpoint#postgres_source DatatransferEndpoint#postgres_source}
    */
    readonly postgresSource?: DatatransferEndpointSettingsPostgresSource;
    /**
    * postgres_target block
    *
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/datatransfer_endpoint#postgres_target DatatransferEndpoint#postgres_target}
    */
    readonly postgresTarget?: DatatransferEndpointSettingsPostgresTarget;
}
export declare function datatransferEndpointSettingsToTerraform(struct?: DatatransferEndpointSettingsOutputReference | DatatransferEndpointSettings): any;
export declare class DatatransferEndpointSettingsOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DatatransferEndpointSettings | undefined;
    set internalValue(value: DatatransferEndpointSettings | undefined);
    private _clickhouseSource;
    get clickhouseSource(): DatatransferEndpointSettingsClickhouseSourceOutputReference;
    putClickhouseSource(value: DatatransferEndpointSettingsClickhouseSource): void;
    resetClickhouseSource(): void;
    get clickhouseSourceInput(): DatatransferEndpointSettingsClickhouseSource | undefined;
    private _clickhouseTarget;
    get clickhouseTarget(): DatatransferEndpointSettingsClickhouseTargetOutputReference;
    putClickhouseTarget(value: DatatransferEndpointSettingsClickhouseTarget): void;
    resetClickhouseTarget(): void;
    get clickhouseTargetInput(): DatatransferEndpointSettingsClickhouseTarget | undefined;
    private _mongoSource;
    get mongoSource(): DatatransferEndpointSettingsMongoSourceOutputReference;
    putMongoSource(value: DatatransferEndpointSettingsMongoSource): void;
    resetMongoSource(): void;
    get mongoSourceInput(): DatatransferEndpointSettingsMongoSource | undefined;
    private _mongoTarget;
    get mongoTarget(): DatatransferEndpointSettingsMongoTargetOutputReference;
    putMongoTarget(value: DatatransferEndpointSettingsMongoTarget): void;
    resetMongoTarget(): void;
    get mongoTargetInput(): DatatransferEndpointSettingsMongoTarget | undefined;
    private _mysqlSource;
    get mysqlSource(): DatatransferEndpointSettingsMysqlSourceOutputReference;
    putMysqlSource(value: DatatransferEndpointSettingsMysqlSource): void;
    resetMysqlSource(): void;
    get mysqlSourceInput(): DatatransferEndpointSettingsMysqlSource | undefined;
    private _mysqlTarget;
    get mysqlTarget(): DatatransferEndpointSettingsMysqlTargetOutputReference;
    putMysqlTarget(value: DatatransferEndpointSettingsMysqlTarget): void;
    resetMysqlTarget(): void;
    get mysqlTargetInput(): DatatransferEndpointSettingsMysqlTarget | undefined;
    private _postgresSource;
    get postgresSource(): DatatransferEndpointSettingsPostgresSourceOutputReference;
    putPostgresSource(value: DatatransferEndpointSettingsPostgresSource): void;
    resetPostgresSource(): void;
    get postgresSourceInput(): DatatransferEndpointSettingsPostgresSource | undefined;
    private _postgresTarget;
    get postgresTarget(): DatatransferEndpointSettingsPostgresTargetOutputReference;
    putPostgresTarget(value: DatatransferEndpointSettingsPostgresTarget): void;
    resetPostgresTarget(): void;
    get postgresTargetInput(): DatatransferEndpointSettingsPostgresTarget | undefined;
}
/**
* Represents a {@link https://www.terraform.io/docs/providers/yandex/r/datatransfer_endpoint yandex_datatransfer_endpoint}
*/
export declare class DatatransferEndpoint extends cdktf.TerraformResource {
    static readonly tfResourceType = "yandex_datatransfer_endpoint";
    /**
    * Create a new {@link https://www.terraform.io/docs/providers/yandex/r/datatransfer_endpoint yandex_datatransfer_endpoint} Resource
    *
    * @param scope The scope in which to define this construct
    * @param id The scoped construct ID. Must be unique amongst siblings in the same scope
    * @param options DatatransferEndpointConfig = {}
    */
    constructor(scope: Construct, id: string, config?: DatatransferEndpointConfig);
    private _description?;
    get description(): string;
    set description(value: string);
    resetDescription(): void;
    get descriptionInput(): string | undefined;
    private _folderId?;
    get folderId(): string;
    set folderId(value: string);
    resetFolderId(): void;
    get folderIdInput(): string | undefined;
    private _id?;
    get id(): string;
    set id(value: string);
    resetId(): void;
    get idInput(): string | undefined;
    private _labels?;
    get labels(): {
        [key: string]: string;
    };
    set labels(value: {
        [key: string]: string;
    });
    resetLabels(): void;
    get labelsInput(): {
        [key: string]: string;
    } | undefined;
    private _name?;
    get name(): string;
    set name(value: string);
    resetName(): void;
    get nameInput(): string | undefined;
    private _settings;
    get settings(): DatatransferEndpointSettingsOutputReference;
    putSettings(value: DatatransferEndpointSettings): void;
    resetSettings(): void;
    get settingsInput(): DatatransferEndpointSettings | undefined;
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
